/* 
 * Source Name : sas_ask.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#include <pthread.h>

#include <sky_extern.h>
#include "sky_inc.h"
#include "sky_ask.h"
#include "sky_app.h"

//////////////////////////////////////////////////////////////////////////////
// EXTERNAL FUNCTION PROTOTYPES
//////////////////////////////////////////////////////////////////////////////
void SaveSatelliteInfo ( Widget w ) ;
void AutoScanSatellite ( Widget w ) ;
Sky_ReturnVal_E LocalOscillatorInfo_Write ( void ) ;

//////////////////////////////////////////////////////////////////////////////
// INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
//////////////////////////////////////////////////////////////////////////////
void ask_okBCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ; 

//////////////////////////////////////////////////////////////////////////////
// INTERAL FUNCTION PROTOTYPES 
//////////////////////////////////////////////////////////////////////////////
void DisplayAskDialog ( Widget w, AskShell_E type, char * txt ) ;
void SetWhoCallAskShell ( AskShell_E val ) ;
AskShell_E WhoCallAskShell ( void ) ;
void ReSetAskShell ( void ) ;

//////////////////////////////////////////////////////////////////////////////
// GLOBAL VARIABLES
//////////////////////////////////////////////////////////////////////////////
static AskShell_E ask_g = SKY_ASK_UNKOWN_E ;

//////////////////////////////////////////////////////////////////////////////
// FUNCTION NAME : ask_okBCallback
// DESCRIPTION   : password dialog modify verify callback
// PARAMETERS    : [in]
//                 [out]
// RETURN VALUE  : void
//////////////////////////////////////////////////////////////////////////////
void
ask_shell_popdownCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   #ifdef DEBUG
   printf ( "inform_shell_popdownCallback\n" ) ;
   #endif

   // Get Parent Widget & Enabled
   EnableWidget ( GetParentWidget ( NULL ) ) ;
}

void
ask_cancelBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
   switch ( WhoCallAskShell ( ) ) {
      case SKY_ASK_SAT_SAVE_E :
         SAT_ValChg_Reset ( ) ;
         break ;
      case SKY_ASK_SAT_DEL_E :
         SAT_ValChg_Reset ( ) ;
         break ;
      case SKY_ASK_TP_DEL_E :
         SAT_ValChg_Reset ( ) ;
         break ;
      case SKY_ASK_AUTOSCAN_E :
         break ;
      case SKY_ASK_EXIT_E :
      default :
         break ;
   }
}
void
ask_okBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
   pthread_attr_t  attr ;

   #ifdef DEBUG
   printf ( "ask_okBCallback\n" ) ;
   #endif

   switch ( WhoCallAskShell ( ) ) {
      case SKY_ASK_SAT_SAVE_E :
         SaveSatelliteInfo ( tuner_satOtherB ) ;
         break ;
      case SKY_ASK_SAT_DEL_E :
         DeleteSatellite ( tuner_satInfoB2 ) ;
         break ;
      case SKY_ASK_TP_DEL_E :
         SAT_ValChg_Set () ;
         DeleteTransponder ( tuner_satinfo_FqSy_menuDelBut ) ;
         break ;
      case SKY_ASK_AUTOSCAN_E :
         SAT_ValChg_Set () ;
         XtManageChild ( autoscan_board ) ;
         AutoScanSatellite ( tuner_satInfoB4 ) ;
         break ;
      case SKY_ASK_EXIT_E :
         finish_sky_media200 ( ) ; 
         exit ( 0 ) ;
      default :
         break ;
   }

}

void DisplayAskDialog ( Widget w, AskShell_E type, char * txt )
{
   XmString      str ;
   Widget        pW ;

   SetWhoCallAskShell ( type ) ;

   str = ( XmString ) strToXmString ( txt ) ;
   XtVaSetValues ( ask_txtlabel, XmNlabelString, str, NULL ) ;
   XmStringFree ( str ) ;

   //  top level shell disable Ų.
   DisableWidget ( GetParentWidget ( w ) ) ;
   XtManageChild ( ask_board ) ;
}
void SetWhoCallAskShell ( AskShell_E val )
{
   ask_g = val ;
}
AskShell_E WhoCallAskShell ( void )
{
   return ask_g ;
}
void ReSetAskShell ( void )
{
   ask_g = SKY_ASK_UNKOWN_E ;
}
