/* 
 * Source Name : sas_password.c
 * Description : about login password
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#include <sky_extern.h>
#include "sky_inc.h"

//////////////////////////////////////////////////////////////////////////////
// EXTERNAL FUNCTION PROTOTYPES
//////////////////////////////////////////////////////////////////////////////
void DisableWidget ( Widget w ) ;
void EnableWidget ( Widget w ) ;
Widget GetParentWidget ( Widget w ) ;

//////////////////////////////////////////////////////////////////////////////
// INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
//////////////////////////////////////////////////////////////////////////////
void error_shell_popupCallback ( Widget w, XtPointer client_data, XtPointer call_data ) ;
void error_shell_popdownCallback ( Widget w, XtPointer client_data, XtPointer call_data ) ;

//////////////////////////////////////////////////////////////////////////////
// INTERAL FUNCTION PROTOTYPES 
//////////////////////////////////////////////////////////////////////////////
void DisplayErrorDialog ( Widget w, char * txt ) ;

//////////////////////////////////////////////////////////////////////////////
// GLOBAL VARIABLES
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// FUNCTION NAME : DisplayErrorDialog
// DESCRIPTION   : password dialog modify verify callback
// PARAMETERS    : [in]
//                 [out]
// RETURN VALUE  : void
//////////////////////////////////////////////////////////////////////////////
void DisplayErrorDialog ( Widget w, char * txt )
{
   XmString      str ;
   Widget        pW ;
   
   str = ( XmString ) strToXmString ( txt ) ;
   XtVaSetValues ( error_txtLab, XmNlabelString, str, NULL ) ;
   XmStringFree ( str ) ;

#if 0
   /*  top level shell disable Ų. */
   DisableWidget ( GetParentWidget ( w ) ) ;
#else
   my_SetWatchCursor ( data_shell ) ;
#endif

   XtManageChild ( error_board ) ;
}

/*
** X-Designer Stub error_shell_popupCallback
*/

void
error_shell_popupCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   #ifdef DEBUG
   printf ( "error_shell_popupCallback : w = %x\n", w ) ;
   #endif
}

/*
** X-Designer Stub error_shell_popdownCallback
*/

void
error_shell_popdownCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   #ifdef DEBUG
   printf ( "error_shell_popdownCallback\n" ) ;
   #endif

#if 0
   /* Get Parent Widget & Enabled*/
   EnableWidget ( GetParentWidget ( NULL ) ) ;
#else
   my_ResetCursor ( data_shell ) ;
#endif

}

