/* 
 * Source Name : sky_ask2.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#include <sky_extern.h>
#include "sky_inc.h"
#include "sky_ask.h"
#include "sky_app.h"

//////////////////////////////////////////////////////////////////////////////
// EXTERNAL FUNCTION PROTOTYPES
//////////////////////////////////////////////////////////////////////////////
void my_SetWatchCursor ( Widget w1 ) ;
void my_ResetCursor ( Widget w1 ) ;

//////////////////////////////////////////////////////////////////////////////
// INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
//////////////////////////////////////////////////////////////////////////////
void ask2_yesBCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ; 
void ask2_noBCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ; 

//////////////////////////////////////////////////////////////////////////////
// INTERAL FUNCTION PROTOTYPES 
//////////////////////////////////////////////////////////////////////////////
void DisplayAsk2Dialog ( Widget w, AskShell_E type, char * txt ) ;
void SetWhoCallAsk2Shell ( AskShell_E val ) ;
AskShell_E WhoCallAsk2Shell ( void ) ;
void ReSetAsk2Shell ( void ) ;

//////////////////////////////////////////////////////////////////////////////
// GLOBAL VARIABLES
//////////////////////////////////////////////////////////////////////////////
static AskShell_E ask2_g = SKY_ASK_UNKOWN_E ;

//////////////////////////////////////////////////////////////////////////////
// FUNCTION NAME : ask_okBCallback
// DESCRIPTION   : password dialog modify verify callback
// PARAMETERS    : [in]
//                 [out]
// RETURN VALUE  : void
//////////////////////////////////////////////////////////////////////////////
void
ask2_shell_popupCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
}
void
ask2_shell_popdownCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   #ifdef DEBUG
   printf ( "ask2_shell_popdownCallback\n" ) ;
   #endif

   /* Get Parent Widget & Enabled */
   /* EnableWidget ( GetParentWidget ( NULL ) ) ; */
   my_ResetCursor ( data_shell ) ;
}

void
ask2_noBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
   switch ( WhoCallAsk2Shell ( ) ) {
      case SKY_ASK_SAT_SAVE_E :
         SAT_ValChg_Reset ( ) ;
         break ;
      case SKY_ASK_SAT_DEL_E :
         SAT_ValChg_Reset ( ) ;
         break ;
      case SKY_ASK_TP_DEL_E :
         SAT_ValChg_Reset ( ) ;
         break ;
      case SKY_ASK_AUTOSCAN_E :
         break ;
      case SKY_ASK_EXIT_E :
         finish_sky_media200 ( ) ; 
         exit ( 0 ) ;
      default :
         break ;
   }
}
void
ask2_yesBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
   #ifdef DEBUG
   printf ( "ask2_yesBCallback\n" ) ;
   #endif

   switch ( WhoCallAsk2Shell ( ) ) {
      case SKY_ASK_SAT_SAVE_E :
         SaveSatelliteInfo ( tuner_satOtherB ) ;
         break ;
      case SKY_ASK_SAT_DEL_E :
         DeleteSatellite ( tuner_satInfoB2 ) ;
         break ;
      case SKY_ASK_TP_DEL_E :
         SAT_ValChg_Set () ;
         DeleteTransponder ( tuner_satinfo_FqSy_menuDelBut ) ;
         break ;
      case SKY_ASK_AUTOSCAN_E :
         SAT_ValChg_Set () ;
         XtManageChild ( autoscan_board ) ;
         AutoScanSatellite ( tuner_satInfoB4 ) ;
         break ;
      case SKY_ASK_EXIT_E :
         SaveSatelliteInfo ( tuner_satOtherB ) ;
         finish_sky_media200 ( ) ; 
         exit ( 0 ) ;
      default :
         break ;
   }

}

void DisplayAsk2Dialog ( Widget w, AskShell_E type, char * txt )
{
   XmString      str ;
   Widget        pW ;

   SetWhoCallAsk2Shell ( type ) ;

   str = ( XmString ) strToXmString ( txt ) ;
   XtVaSetValues ( ask2_textLab, XmNlabelString, str, NULL ) ;
   XmStringFree ( str ) ;

   //  top level shell disable Ų.
#if 1
   my_SetWatchCursor ( data_shell ) ;
#else
   DisableWidget ( GetParentWidget ( w ) ) ;
#endif
   XtManageChild ( ask2_msgBox ) ;
}
void SetWhoCallAsk2Shell ( AskShell_E val )
{
   ask2_g = val ;
}
AskShell_E WhoCallAsk2Shell ( void )
{
   return ask2_g ;
}
void ReSetAsk2Shell ( void )
{
   ask2_g = SKY_ASK_UNKOWN_E ;
}
