/* 
 * Source Name : sky_sat_del.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_sat.h"
#include "sky_ask.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
void DisplayAskDialog ( Widget w, AskShell_E, char * ) ;
void DisplayErrorDialog ( Widget w, char * ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/
void
tuner_satDelBCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :     ΰ Ѵ.
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
tuner_satInfoB1_1Callback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  SAT_ValChg_Reset ( ) ;
  /*----------------------------------------------------------*/
  /* Ask Save or Not ? */
  /*----------------------------------------------------------*/
  XtUnmanageChild ( ask2_helpB ) ;
  XtManageChild ( ask2_cancelB ) ;
  DisplayAsk2Dialog ( w, SKY_ASK_SAT_SAVE_E, "Satellite information is changed.\nDo you want to save it ?" ) ;
}

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :     ΰ Ѵ.
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
tuner_satOtherBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  SAT_ValChg_Reset ( ) ;
  /*----------------------------------------------------------*/
  /* Ask Save or Not ? */
  /*----------------------------------------------------------*/
  XtUnmanageChild ( ask2_helpB ) ;
  XtManageChild ( ask2_cancelB ) ;
  DisplayAsk2Dialog ( w, SKY_ASK_SAT_SAVE_E, "Satellite information is changed.\nDo you want to save it ?" ) ;

  /* Just Test */
}

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :     ΰ Ѵ.
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
tuner_satDelBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  Sky_LastInfo_S    sky_r ;

  read_initfile ( & sky_r ) ;
  if ( sky_r . num_of_satellite <= 1 ) {
    DisplayErrorDialog ( w, "Warning !\nCan't delete the last satellite" ) ;
  } else {
    XtUnmanageChild ( ask2_helpB ) ;
    XtManageChild ( ask2_cancelB ) ;
    DisplayAsk2Dialog ( w, SKY_ASK_SAT_DEL_E, "Do you want to delete selected satellite ?" ) ;  
  }
}

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :  Transponder   ΰ Ѵ.
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
tuner_fqsyDelCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  int   pos ;
  int   numTp ;

  numTp = Sky_GetNumOfTransponder () ;

  #ifdef DEBUG
  printf ( "%s : %d : Num of Transponder = %d\n", __FILE__, __LINE__, numTp ) ;
  #endif

  if ( !numTp ) {
    DisplayErrorDialog ( w, "Warning !!\nThere is No Transponder" ) ;
    return ;
  }
  pos = XmListGetKbdItemPos ( tuner_satinfo_FqSyList_list ) ;
  if ( pos <= 0 ) {
    DisplayErrorDialog ( w, "No selected transponder\nPlease, select a transponder" ) ;
  } else {
    XtUnmanageChild ( ask2_helpB ) ;
    XtManageChild ( ask2_cancelB ) ;
    DisplayAsk2Dialog ( w, SKY_ASK_TP_DEL_E, "Do you want to delete selected transponder ?" ) ;  
  }
}
tuner_satAutoScanBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  int    numTp ;

  numTp = Sky_GetNumOfTransponder () ;

  if ( numTp ) {
    XtUnmanageChild ( ask2_helpB ) ;
    XtManageChild ( ask2_cancelB ) ;
    DisplayAsk2Dialog ( w, SKY_ASK_AUTOSCAN_E, "Auto scan for all transponders.\nIt will tak long time.\nDo you want to continue?" ) ;
  } else {
    DisplayErrorDialog ( w, "Warning !!\nThere is No Transponder" ) ;
  }
}

