#ifndef _sky_autoscan_h_
#define _sky_autoscan_h_

#define MAX_AUTOSCAN_TRANSPONDER_RESULT_STR_LEN   200 
#define SKY_AUTOSCAN_TIMEOUT                      100  /* msec */
#define SKY_AUTOSCAN_FINISH_TIMEOUT               5000  /* msec */
#define SKY_PTHREAD_DELAY_SEC                     1     /* sec */

#define SKY_AUTOSCAN_RESULT_FILE_NAME             ".autoscan.result"

typedef enum { 
  AUTOSCAN_NOT_STARTED , 
  AUTOSCAN_CONTINUED_E , 
  AUTOSCAN_FINISHED_E 
} Sky_AutoScan_E ;

typedef enum {
  AUTOSCAN_NOT_CHANGED ,
  AUTOSCAN_CHANGED 
} Sky_AutoScan_ChangeFlag_E ;

typedef enum {
  AUTOSCAN_READ_E ,
  AUTOSCAN_NOT_READ_E 
} Sky_AutoScan_ReadFlag_E ;

typedef struct {
  int            result_pos ;
  char           result_tp_str [ MAX_AUTOSCAN_TRANSPONDER_RESULT_STR_LEN + 1 ] ;
  char           next_sc_str [ MAX_AUTOSCAN_TRANSPONDER_RESULT_STR_LEN + 1 ] ; 
  char           result_title_str [ MAX_AUTOSCAN_TRANSPONDER_RESULT_STR_LEN + 1 ] ; 
  SI_STRUCTURE   si_info ;
  int            next_selected_pos ;
} Sky_AutoScan_TransponderInfo_S ;

typedef struct {
  Sky_AutoScan_E                  flag ;
  int                             sequence ;
  Sky_AutoScan_TransponderInfo_S  sts ; 
  int                             total_bar_count ;
  Sky_AutoScan_ReadFlag_E         read_flag ;
} Sky_AutoScan_Result_S ;

typedef struct {
  int             count ;
  LNB_STRUCTURE   lnb_r ;
  TR_STRUCTURE    tp_p [ MAX_TRANSPONDER_NUM ] ;
} Sky_AutoScan_Start_S ;

#endif
