/* 
 * Source Name : sky_autoscan_bar.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_data.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void AutoScanProgressBar_Initialization ( void ) ;
void AutoScanProgressBar_Reset ( void ) ;
void AutoScanProgressBar_Progress ( int cur_count, int tot_count ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/
static Widget * g_Bar [ MAX_PROGRESS_BAR_NUM ] ;

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void AutoScanProgressBar_Initialization ( void ) 
{
  g_Bar [ 0 ] = & autoscan_stsL1 ;
  g_Bar [ 1 ] = & autoscan_stsL2 ;
  g_Bar [ 2 ] = & autoscan_stsL3 ;
  g_Bar [ 3 ] = & autoscan_stsL4 ;
  g_Bar [ 4 ] = & autoscan_stsL5 ;
  g_Bar [ 5 ] = & autoscan_stsL6 ;
  g_Bar [ 6 ] = & autoscan_stsL7 ;
  g_Bar [ 7 ] = & autoscan_stsL8 ;
  g_Bar [ 8 ] = & autoscan_stsL9 ;
  g_Bar [ 9 ] = & autoscan_stsL10 ;
  g_Bar [ 10 ] = & autoscan_stsL11 ;
  g_Bar [ 11 ] = & autoscan_stsL12 ;
  g_Bar [ 12 ] = & autoscan_stsL13 ;
  g_Bar [ 13 ] = & autoscan_stsL14 ;
  g_Bar [ 14 ] = & autoscan_stsL15 ;
  g_Bar [ 15 ] = & autoscan_stsL16 ;
  g_Bar [ 16 ] = & autoscan_stsL17 ;
  g_Bar [ 17 ] = & autoscan_stsL18 ;
  g_Bar [ 18 ] = & autoscan_stsL19 ;
  g_Bar [ 19 ] = & autoscan_stsL20 ;
  g_Bar [ 20 ] = & autoscan_stsL21 ;
  g_Bar [ 21 ] = & autoscan_stsL22 ;
  g_Bar [ 22 ] = & autoscan_stsL23 ;
  g_Bar [ 23 ] = & autoscan_stsL24 ;
  g_Bar [ 24 ] = & autoscan_stsL25 ;
  g_Bar [ 25 ] = & autoscan_stsL26 ;
  g_Bar [ 26 ] = & autoscan_stsL27 ;
  g_Bar [ 27 ] = & autoscan_stsL28 ;
  g_Bar [ 28 ] = & autoscan_stsL29 ;
  g_Bar [ 29 ] = & autoscan_stsL30 ;
  g_Bar [ 30 ] = & autoscan_stsL31 ;
  g_Bar [ 31 ] = & autoscan_stsL32 ;
  g_Bar [ 32 ] = & autoscan_stsL33 ;
  g_Bar [ 33 ] = & autoscan_stsL34 ;
  g_Bar [ 34 ] = & autoscan_stsL35 ;
}
void AutoScanProgressBar_Reset ( void ) 
{
  int       i ;
  XmString  xmStr ;
  char      txt [ 10 ] ;

  for ( i = 0 ; i < MAX_PROGRESS_BAR_NUM ; i ++ ) {
    XtUnmapWidget ( * g_Bar [ i ] ) ;
  }

  /*-------------------------------------------------------*/
  /* Percentage Display */
  /*-------------------------------------------------------*/
  sprintf ( txt, "%d%s", 0, "%" ) ;
  xmStr = ( XmString ) strToXmString ( txt ) ;
  XtVaSetValues ( autoscan_stsLab2, XmNlabelString, xmStr, NULL ) ; 
  XmStringFree ( xmStr ) ;
}
void AutoScanProgressBar_Progress ( int cur_count, int tot_count )
{
  int  percent ;
  int  iterate ;
  int  i ;

  char       txt [ 20 ] ;
  XmString   xmStr ;

  /*-------------------------------------------------------*/
  /* Progress Bar Display */
  /*-------------------------------------------------------*/
  percent = ( cur_count * 100 ) / tot_count ;
  iterate = ( MAX_PROGRESS_BAR_NUM * cur_count ) / tot_count ;
  
  #ifdef DEBUG
  /*printf ( "%s : %d : cur_count = %d, tot_count = %d, percent = %d%s, iterate = %d\n",
            __FILE__, __LINE__, cur_count, tot_count, percent, "%", iterate ) ;*/
  #endif

  for ( i = 0 ; i < iterate ; i ++ ) {
    XtMapWidget ( *g_Bar [ i ] ) ;
  }
  for ( i = iterate ; i < MAX_PROGRESS_BAR_NUM ; i ++ ) {
    XtUnmapWidget ( *g_Bar [ i ] ) ;
  }

  /*-------------------------------------------------------*/
  /* Percentage Display */
  /*-------------------------------------------------------*/
  sprintf ( txt, "%d%s", percent, "%" ) ;
  xmStr = ( XmString ) strToXmString ( txt ) ;
  XtVaSetValues ( autoscan_stsLab2, XmNlabelString, xmStr, NULL ) ; 
  XmStringFree ( xmStr ) ;
}
