/* 
 * Source Name : sky_data_add_edit.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_data.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
void Compare_DATA_Info_Reset ( void ) ;
void Compare_DATA_OldInfo_Set ( int count, DATAPROGRAM_STRUCTURE * old_tp ) ;
Sky_ReturnVal_E Compare_Old_With_DATA_NewInfo ( int count, DATAPROGRAM_STRUCTURE * new_tp ) ;
rcl_return_code AvailableDataLister_GetPosById ( int newId, int * pos );

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void SetLabelDataSubShell ( char * lab ) ;
void ClearDataSubShell ( void ) ;
Sky_ReturnVal_E GetValDataShell ( Widget w, DATAPROGRAM_STRUCTURE * tp_p ) ;
void SetValDataSubShell ( DATAPROGRAM_STRUCTURE * tp_p ) ;
DATA_B_Select_E GetAddEditData ( void ) ;
Sky_ReturnVal_E IsThisUniqueDataPID ( int tp_id, unsigned short pid ) ;
Sky_ReturnVal_E 
IsThisUniqueDataPID_2 ( int tp_id, unsigned short pid, DATAPROGRAM_STRUCTURE * old_data_r ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
dataAdd_shell_popupCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
#if 0
  XtSetSensitive ( data_shell, False ) ;
#endif
}
void
dataAdd_shell_popdownCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
#if 0
  XtSetSensitive ( data_shell, True ) ;
#endif
}

void
dataAdd_addBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  SetLabelDataSubShell ( DATA_ADD_TITLE_STR ) ;
  ClearDataSubShell ( ) ;
  XtManageChild ( dataAdd_board ) ;
#if 0
  XtSetSensitive ( data_shell, False ) ;
#endif
}

void
dataAdd_editBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  DATAPROGRAM_STRUCTURE data_r ;
  int                   pos ;

  DATAPROGRAM_STRUCTURE old_data_r [ MAX_DATA_NUM ] ;
  int                   old_count ;
  int                   i ;
  int                   tp_id ;
  Sky_LastInfo_S        sky_r ;

  int                   count ;
  int                 * position_p ;

  Boolean               rt ;

  /*--------------------------------------------------------*/
  /* Get Transponder Number */
  /*--------------------------------------------------------*/
  read_initfile ( & sky_r ) ;
  tp_id = sky_r . transponder_id ;
  if ( tp_id <= 0 ) {
    #ifdef DEBUG_FAIL
    printf ( "%s : %d : Invalid Transponder Number = %d\n", __FILE__, __LINE__, tp_id ) ;
    #endif

    return ;
  }
  /*--------------------------------------------------------*/
  /* Setting Title & Clear */
  /*--------------------------------------------------------*/
  SetLabelDataSubShell ( DATA_EDIT_TITLE_STR ) ;
  ClearDataSubShell ( ) ;

  /*--------------------------------------------------------*/
  /* get data position */
  /*--------------------------------------------------------*/
  /*
  XtVaGetValues ( data_PE_form1_listLister, XmNselectedPositionCount, & count, NULL ) ;
  XtVaGetValues ( data_PE_form1_listLister, XmNselectedPositions, & position, NULL ) ;
  */
  rt = XmListGetSelectedPos ( data_PE_form1_listLister, & position_p, & count ) ;
  if ( rt != True ) {

     #ifdef DEBUG_FAIL
     printf ( "%s : %d : XmListGetSelectedPos () Fail\n", __FILE__, __LINE__ ) ;
     #endif

     return ;
  }
  if ( count == 0 ) {

     #ifdef DEBUG_FAIL
     printf ( "%s : %d : XmListGetSelectedPos () : empty position\n", __FILE__, __LINE__ ) ;
     #endif

     return ;
  }
  pos = * position_p ;
  /*pos = XmListGetKbdItemPos ( data_PE_form1_listLister ) ; */
  if ( pos == 0 ) {

     #ifdef DEBUG_FAIL
     printf ( "%s : %d : XmListGetKbdItemPos () : empty position\n", __FILE__, __LINE__ ) ;
     #endif

     return ;
  }

  /*--------------------------------------------------------*/
  /* get transponder info */
  /*--------------------------------------------------------*/
  memset ( & data_r, 0, sizeof ( data_r ) ) ;
  data_r . DataNumber = tp_id * 100 + pos ;
  if ( Sky_GetInfoData ( & data_r ) != FALSE ) {

     #ifdef DEBUG_FAIL
     printf ( "%s : %d : Sky_GetInfoData () Fail\n", __FILE__, __LINE__ ) ;
     #endif

     return ;
  }

  /*--------------------------------------------------------*/
  /* setting data info */
  /*--------------------------------------------------------*/
  SetValDataSubShell ( & data_r ) ;

  /*--------------------------------------------------------*/
  /* display dataAdd_shell */
  /*--------------------------------------------------------*/
  XtManageChild ( dataAdd_board ) ;
#if 0
  XtSetSensitive ( data_shell, False ) ;
#endif

  /*--------------------------------------------------------*/
  /* Save Old Data Information */
  /*--------------------------------------------------------*/
  old_count = Sky_GetNumOfData ( tp_id ) ;
  memset ( old_data_r, 0, sizeof ( old_data_r ) ) ;
  for ( i = 0 ; i < old_count ; i ++ ) {
    old_data_r [ i ] . DataNumber = tp_id * 100 + i + 1 ;
    if ( Sky_GetInfoData ( & old_data_r [ i ] ) != FALSE ) {

       #ifdef DEBUG_FAIL
       printf ( "%s : %d : Sky_GetInfoData () Fail\n", __FILE__, __LINE__ ) ;
       #endif

       return ;
    }
  }
  Compare_DATA_OldInfo_Set ( old_count, old_data_r ) ;


}

void
dataAdd_okBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  DATAPROGRAM_STRUCTURE   data_r ;
  DATAPROGRAM_STRUCTURE   old_data_r ;
  SETDATA_STRUCTURE       old_setdata_r ;
  SETDATA_STRUCTURE       new_setdata_r ;
  DATA_B_Select_E         type ;
  int                     numOfData ;
  int                     pos ;
  int                     tp_id ;
  Sky_LastInfo_S          sky_r ;

  int                   * position ;
  int                     count ;
  int                     i ;
  int                     new_count ;
  DATAPROGRAM_STRUCTURE   new_data [ MAX_DATA_NUM ] ;

  Sky_LastInfo_S          sky_p ;

  /*----------------------------------------------------------*/
  /* Get Add/Edit Transponder Value from Pannel */
  /*----------------------------------------------------------*/
  memset ( & data_r, 0, sizeof ( data_r ) ) ;
  if ( GetValDataShell ( w, & data_r ) != SKY_SUCCESS ) {
#if 0
    XtSetSensitive ( data_shell, True ) ;
#endif
    return ;
  } 

  /*----------------------------------------------------------*/
  /* Current Transponder Id */
  /*----------------------------------------------------------*/
  read_initfile ( & sky_r ) ;
  tp_id = sky_r . transponder_id ;

  #ifdef DEBUG
  printf ( "%s : %d : tp_id = %d\n", __FILE__, __LINE__, tp_id ) ;
  #endif

  /*----------------------------------------------------------*/
  /* Add or Edit ? */
  /*----------------------------------------------------------*/
  switch ( GetAddEditData ( ) ) {
    case DATA_ADD_E :

      /*------------------------------------------------------*/
      /* check Unique Data Pid */
      /*------------------------------------------------------*/
      if ( IsThisUniqueDataPID ( tp_id, data_r . DataPID ) != SKY_SUCCESS ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : IsThisUniqueDataPID () Fail\n", __FILE__, __LINE__ ) ;
        #endif

        /*
        DisplayErrorDialog ( data_menu_PE, "Warning !! Duplicated Data PID\nPlease, Enter Unique PID" ) ;
        */
        break ;
      }

      /*------------------------------------------------------*/
      /* make message */
      /*------------------------------------------------------*/
      data_r . SetFlag = 0 ;
      data_r . ManualAdd = MANUAL_ADD ;

      /*------------------------------------------------------*/
      /* Add Data */
      /*------------------------------------------------------*/
      if ( Sky_AddData ( tp_id, & data_r ) != FALSE ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : Sky_AddData () Fail\n", __FILE__, __LINE__ ) ;
        #endif

        break ;
      }
      #ifdef DEBUG
      printf ( "%s : %d : data_r . DataNumber = %d\n", __FILE__, __LINE__, data_r . DataNumber ) ;
      #endif

      /*------------------------------------------------------*/
      /* Satellite Information Changed Flag Setting */
      /*------------------------------------------------------*/
      SAT_ValChg_Set ( ) ;

      /*------------------------------------------------------*/
      /* Re-Display Data Info */
      /*------------------------------------------------------*/
      DisplayDataInfoToPanel ( data_menu_PE, tp_id ) ;

      /*------------------------------------------------------*/
      /* Get New add Data position */
      /*------------------------------------------------------*/
      if ( AvailableDataLister_GetPosById ( data_r . DataNumber, & pos ) != RCL_SUCCESS ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : AvailableDataLister_GetPosById () Fail\n", __FILE__, __LINE__ ) ;
        #endif

      }
      XmListSelectPos ( data_PE_form1_listLister, pos + 1, False ) ;

      break ;

    case DATA_EDIT_E :

      /*------------------------------------------------------*/
      /* Cursor position */
      /*------------------------------------------------------*/
      memset ( & old_data_r, 0, sizeof ( old_data_r ) ) ;
      XmListGetSelectedPos ( data_PE_form1_listLister, & position, & count ) ;
      if ( count == 0 ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : XmListGetSelectedPos () . count = %d\n", __FILE__, __LINE__, count ) ;
        #endif

        return ;
      }
      pos = *position ;
      /*old_data_r . DataNumber = tp_id * 100 + pos ;*/
      if ( AvailableDataLister_GetIdByPos ( pos - 1, & old_data_r . DataNumber ) != SKY_SUCCESS ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : AvailableDataLister_GetIdByPos () Fail. pos = %d\n", __FILE__, __LINE__, pos ) ;
        #endif

        return ;
      }

      #ifdef DEBUG
      printf ( "%s : %d : tp_id = %d, pos = %d, DataNumber = %d\n", __FILE__, __LINE__, tp_id, pos, old_data_r . DataNumber ) ;
      #endif

      /*------------------------------------------------------*/
      /* Get Data Information */
      /*------------------------------------------------------*/
      if ( Sky_GetInfoData ( & old_data_r ) != FALSE ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : Sky_GetInfoData () Fail\n", __FILE__, __LINE__ ) ;
        #endif

        return ;
      }

      /*------------------------------------------------------*/
      /* check Unique Data Pid */
      /*------------------------------------------------------*/
      if ( IsThisUniqueDataPID_2 ( tp_id, data_r . DataPID, & old_data_r ) != SKY_SUCCESS ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : IsThisUniqueDataPID_2 () Fail\n", __FILE__, __LINE__ ) ;
        #endif
        /*
        DisplayErrorDialog ( data_menu_PE, "Warning !! Duplicated Data PID\nPlease, Enter Unique PID" ) ;
        */
        break ;
      }

      /*------------------------------------------------------*/
      /* SetFlag == 1 -> Release & Set PID
      /*------------------------------------------------------*/
      memset ( & old_setdata_r, 0, sizeof ( SETDATA_STRUCTURE ) );
      memset ( & new_setdata_r, 0, sizeof ( SETDATA_STRUCTURE ) );

      old_setdata_r . DataPID = old_data_r . DataPID  ;
      old_setdata_r . Encapsulation = old_data_r . Encapsulation  ;

      new_setdata_r . DataPID = data_r . DataPID  ;
      new_setdata_r . Encapsulation = data_r . Encapsulation  ;

      if ( old_data_r . SetFlag ) {
        if ( Sky_ReleaseNetworkPID ( old_setdata_r ) != FALSE ) {

          #ifdef DEBUG_FAIL
          printf ( "%s : %d : Sky_ReleaseNetworkPID () fail\n", __FILE__, __LINE__ ) ;
          #endif

        } else if ( Sky_SetNetworkPID ( new_setdata_r ) != FALSE ) {

          #ifdef DEBUG_FAIL
          printf ( "%s : %d : Sky_SetNetworkPID () fail\n", __FILE__, __LINE__ ) ;
          #endif

        }
      }

      /*------------------------------------------------------*/
      /* Update Data */
      /*------------------------------------------------------*/
      old_data_r . DataPID = data_r . DataPID ;
      old_data_r . Encapsulation = data_r . Encapsulation ;
      if ( Sky_UpdateData ( old_data_r ) != FALSE ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : Sky_UpdateTransponder () Fail\n", __FILE__, __LINE__ ) ;
        #endif

      }
      /*------------------------------------------------------*/
      /* Compare Old TP & New TP */
      /*------------------------------------------------------*/
      new_count = Sky_GetNumOfData ( tp_id ) ;
      memset ( new_data, 0, sizeof ( new_data ) ) ;
      for ( i = 0 ; i < new_count ; i ++ ) {
        new_data [ i ] . DataNumber = tp_id * 100 + i + 1 ;
        if ( Sky_GetInfoData ( & new_data [ i ] ) != FALSE ) {

           #ifdef DEBUG_FAIL
           printf ( "%s : %d : Sky_GetInfoData () Fail\n", __FILE__, __LINE__ ) ;
           #endif
        }
      }
      if ( Compare_Old_With_DATA_NewInfo ( new_count, new_data ) == SKY_SUCCESS ) {
        SAT_ValChg_Set ( ) ;
      }

      /*------------------------------------------------------*/
      /* Re-Display Data Info */
      /*------------------------------------------------------*/
      DisplayDataInfoToPanel ( data_menu_PE, tp_id ) ;

      /*------------------------------------------------------*/
      /* Old Position Select */
      /*------------------------------------------------------*/
      List_SelectedScrolled ( data_PE_form1_listLister, pos, 13 ) ;

      break ;

    default :
    
      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Invalid Trasnponder Add/Edit?\n", __FILE__, __LINE__ ) ;
      #endif

      return ;
  }

}

Sky_ReturnVal_E GetValDataShell ( Widget w, DATAPROGRAM_STRUCTURE * tp_p ) 
{
  char * txt ;
  int    f_tmp ;

  /*----------------------------------------------------------------*/
  /* get pid value */
  /*----------------------------------------------------------------*/
  txt = ( char * ) XmTextGetString ( data_PE_form1_DPTxt ) ;
  if ( *txt == ( char )NULL ) {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : empty data pid\n", __FILE__, __LINE__ ) ;
    #endif

    /*
    DisplayErrorDialog ( w, "Warning !!\nEmpty Data PID; Please, enter correct PID" ) ;
    */
    return SKY_FAIL ;
  }
  sscanf ( txt, "%x", & f_tmp ) ;
  XtFree ( txt ) ;

  if ( f_tmp <= 0 ) {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : empty data pid\n", __FILE__, __LINE__ ) ;
    #endif

    /*
    DisplayErrorDialog ( w, "Warning !!\nInvalid Data PID; Please, enter correct PID" ) ;
    */
    return SKY_FAIL ;
  }
  tp_p -> DataPID = f_tmp ;
  
  /*----------------------------------------------------------------*/
  /* get Service type */
  /*----------------------------------------------------------------*/
  if ( XmToggleButtonGetState ( data_PE_form1_STRadB1 ) == True ) {
    tp_p -> Encapsulation = DATA_PIPING ;
  } else if ( XmToggleButtonGetState ( data_PE_form1_STRadB2 ) == True ) {
    tp_p -> Encapsulation = DATA_STREAMING ;
  } else if ( XmToggleButtonGetState ( data_PE_form1_STRadB3 ) == True ) {
    tp_p -> Encapsulation = MULTIPROTOCOL_ENCAPSULATION ;
  } else if ( XmToggleButtonGetState ( data_PE_form1_STRadB4 ) == True ) {
    tp_p -> Encapsulation = DATA_STREAMING_PES_1 ;
  } else {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : empty service type\n", __FILE__, __LINE__ ) ;
    #endif

    /*
    DisplayErrorDialog ( w, "Warning !!\nEmpty Service Type; Please, select correct Type" ) ;
    */
    return SKY_FAIL ;
  }

  return SKY_SUCCESS ;
}
void SetValDataSubShell ( DATAPROGRAM_STRUCTURE * tp_p ) 
{
  char  txt [ 100 ] ;

  /* Data PID */
  sprintf ( txt, "%x", tp_p -> DataPID ) ;
  XmTextSetString ( data_PE_form1_DPTxt, txt ) ;

  /* Service type */
  switch ( tp_p -> Encapsulation ) {
    case DATA_PIPING :
      XmToggleButtonSetState ( data_PE_form1_STRadB1, True, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB2, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB3, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB4, False, False ) ;
      break ;

    case DATA_STREAMING :
      XmToggleButtonSetState ( data_PE_form1_STRadB1, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB2, True, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB3, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB4, False, False ) ;
      break ;

    case MULTIPROTOCOL_ENCAPSULATION :
      XmToggleButtonSetState ( data_PE_form1_STRadB1, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB2, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB3, True, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB4, False, False ) ;
      break ;

    case DATA_STREAMING_PES_1 :
      XmToggleButtonSetState ( data_PE_form1_STRadB1, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB2, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB3, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB4, True, False ) ;
      break ;

    default :
      XmToggleButtonSetState ( data_PE_form1_STRadB1, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB2, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB3, False, False ) ;
      XmToggleButtonSetState ( data_PE_form1_STRadB4, False, False ) ;
      break ;
  }
}

void SetLabelDataSubShell ( char * lab )
{
  XmString   str ;

  str = ( XmString ) strToXmString ( lab ) ;

  /* addtrans_shell title setting */
  XtVaSetValues ( dataAdd_shell, XmNtitle, lab, NULL ) ;

  /* addtrans_label setting */
  XtVaSetValues ( dataAdd_titleLab, XmNlabelString, str, NULL ) ;

  XmStringFree ( str ) ;
}
void ClearDataSubShell ( void )
{
  XmTextSetString ( data_PE_form1_DPTxt, NULL ) ;

  XmToggleButtonSetState ( data_PE_form1_STRadB1, True, False ) ;
  XmToggleButtonSetState ( data_PE_form1_STRadB2, False, False ) ;
  XmToggleButtonSetState ( data_PE_form1_STRadB3, False, False ) ;
  XmToggleButtonSetState ( data_PE_form1_STRadB4, False, False ) ;
}


DATA_B_Select_E GetAddEditData ( void ) 
{
  XmString   str ;
  Boolean    rt ;
  char     * txt ;

  XtVaGetValues ( dataAdd_titleLab, XmNlabelString, & str, NULL ) ;
  rt = XmStringGetLtoR ( str, XmFONTLIST_DEFAULT_TAG, & txt ) ;
  XmStringFree ( str ) ;
  if ( rt != True ) {
    #ifdef DEBUG_FAIL
    printf ( "%s : %d : XmStringGetLtoR() fail\n", __FILE__, __LINE__ ) ;
    #endif

    return DATA_UNKNOWN_E ;
  }

  if ( ! strcmp ( txt, DATA_ADD_TITLE_STR ) ) {
    return DATA_ADD_E ;
  } else if ( ! strcmp ( txt, DATA_EDIT_TITLE_STR ) ) {
    return DATA_EDIT_E ;
  } else {
    return DATA_UNKNOWN_E ;
  }
}
Sky_ReturnVal_E IsThisUniqueDataPID ( int tp_id, unsigned short pid )
{
  DATAPROGRAM_STRUCTURE  data_r ;
  int                    numData ;
  int                    i ;

  /* Get Data PID Info */
  numData = Sky_GetNumOfData ( tp_id ) ;
  for ( i = 0 ; i < numData ; i ++ ) {
    data_r . DataNumber = tp_id * 100 + i + 1 ;
    if ( Sky_GetInfoData ( & data_r ) != FALSE ) {
      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Sky_GetInfoData () fail\n", __FILE__, __LINE__ ) ;
      #endif
 
      continue ;
    }

    if ( pid == data_r . DataPID ) {
      return SKY_FAIL ;
    }
  }
  
  return SKY_SUCCESS ;
}
Sky_ReturnVal_E 
IsThisUniqueDataPID_2 ( int tp_id, unsigned short pid, DATAPROGRAM_STRUCTURE * old_data_r )
{
  DATAPROGRAM_STRUCTURE  data_r ;
  int                    numData ;
  int                    i ;

  /* Get Data PID Info */
  numData = Sky_GetNumOfData ( tp_id ) ;
  for ( i = 0 ; i < numData ; i ++ ) {
    data_r . DataNumber = tp_id * 100 + i + 1 ;

    if ( data_r . DataNumber == old_data_r -> DataNumber ) {
      continue ;
    }

    if ( Sky_GetInfoData ( & data_r ) != FALSE ) {
      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Sky_GetInfoData () fail\n", __FILE__, __LINE__ ) ;
      #endif
 
      continue ;
    }

    if ( pid == data_r . DataPID ) {
      return SKY_FAIL ;
    }
  }
  
  return SKY_SUCCESS ;
}
