/* 
 * Source Name : sky_data_del.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_sat.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
rcl_return_code AvailableDataLister_GetIdByPos ( int pos, int * newId ) ;
void SAT_ValChg_Set ( void ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void DeleteTransponder ( Widget w ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
dataAdd_delBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
   int                    position ;
   int                    tmp ;
   Sky_LastInfo_S         sky_p ;
   DATAPROGRAM_STRUCTURE  data_r ;
   SETDATA_STRUCTURE      setdata_r ;
   int                  * pos_p ;
   int                    count ;

   read_initfile ( & sky_p ) ;

   /*-----------------------------------------------*/
   /* position ? */
   /*-----------------------------------------------*/
#if 1
   XmListGetSelectedPos ( data_PE_form1_listLister, & pos_p, & count ) ;
   if ( count == 0 ) {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Unselected Data\n", __FILE__, __LINE__ ) ;
      #endif

      return ;
   }
   position = *pos_p ;
#else
   position = XmListGetKbdItemPos ( data_PE_form1_listLister ) ;
   if ( position <= 0 ) {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Unselected Data\n", __FILE__, __LINE__ ) ;
      #endif

      return ;
   }
#endif
   /*-----------------------------------------------*/
   /* position -> id */
   /*-----------------------------------------------*/
   if ( AvailableDataLister_GetIdByPos ( position - 1, & tmp ) != RCL_SUCCESS ) {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : AvailableDataLister_GetIdByPos () Fail\n", __FILE__, __LINE__ ) ;
      #endif

      return ;
   }

   #ifdef DEBUG
   printf ( "%s : %d : delete DataNumber = %d, selected position = %d\n", __FILE__, __LINE__, tmp, position ) ;
   #endif

   /*-----------------------------------------------*/
   /* If Set Network PID, release -> Delete */
   /*-----------------------------------------------*/
   if ( SetDataLister_GetPosById ( tmp, & position ) != RCL_SUCCESS ) {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : SetDataLister_GetIdByPos () Fail\n", __FILE__, __LINE__ ) ;
      #endif

   } else { /* ϸ release network pid */

     #ifdef DEBUG
     printf ( "%s : %d : delete Set DataNumber = %d, list position = %d\n", __FILE__, __LINE__, tmp, position ) ;
     #endif

      memset ( & data_r, 0, sizeof ( DATAPROGRAM_STRUCTURE ) ) ;
      data_r . DataNumber = tmp ;
      if ( Sky_GetInfoData ( & data_r ) != FALSE ) {
        #ifdef DEBUG_FAIL
        printf ( "%s : %d : Sky_ReleaseNetworkPID () Fail\n", __FILE__, __LINE__ ) ;
        #endif

        return ;
      }

      memset ( & setdata_r, 0, sizeof ( SETDATA_STRUCTURE ) ) ;
      setdata_r . DataPID = data_r . DataPID ;
      setdata_r . Encapsulation = data_r . Encapsulation ;
      if ( Sky_ReleaseNetworkPID ( setdata_r ) != FALSE ) {
        #ifdef DEBUG_FAIL
        printf ( "%s : %d : Sky_ReleaseNetworkPID () Fail\n", __FILE__, __LINE__ ) ;
        #endif
      }
   }

   
   /*-----------------------------------------------*/
   /* delete data */
   /*-----------------------------------------------*/
   memset ( & data_r, 0, sizeof ( data_r ) ) ;
   data_r . DataNumber = tmp ;
   if ( Sky_DeleteData ( data_r ) != FALSE ) {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Sky_DeleteData () Fail\n", __FILE__, __LINE__ ) ;
      #endif

      return ;
   }

   /*------------------------------------------------------*/
   /* Re-Display Data Info */
   /*------------------------------------------------------*/
   DisplayDataInfoToPanel ( data_menu_PE, data_r . DataNumber / 100 ) ;

   /* ù° list selectѴ. */
   List_SelectedScrolled ( data_PE_form1_listLister, 1, 13 ) ;
   List_SelectedScrolled ( data_PE_form3_list_lister, 1, 15 ) ;

   /*------------------------------------------------------*/
   /* Satellite Information Changed Flag Setting */
   /*------------------------------------------------------*/
   SAT_ValChg_Set ( ) ;

}
