/* 
 * Source Name : sky_exit.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif
#include <errno.h>

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_data.h"
#include "sky_autoscan.h"
#include "sky_ask.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
void DisplayAsk2Dialog ( Widget w, AskShell_E type, char * txt ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
data_exitBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
   Sky_ReturnVal_E ret1 ;
   char            buf [ 100 ] ;
   XmString        str ;

   #ifdef DEBUG
   printf ( "Good bye !\n" ) ;
   #endif

   if ( SAT_ValChg_Get () ) {
     strcpy ( buf, "Save changes before exiting ?" ) ;
     str = ( XmString ) strToXmString ( "Cancel" ) ;
     XtManageChild ( ask2_cancelB ) ;
     XtManageChild ( ask2_helpB ) ;
     XtVaSetValues ( ask2_helpB, XmNlabelString, str, NULL ) ;
     XmStringFree ( str ) ; 
   } else {
     strcpy ( buf, "Do you really want to exit ?" ) ;
     str = ( XmString ) strToXmString ( "No" ) ;
     XtUnmanageChild ( ask2_cancelB ) ;
     XtManageChild ( ask2_helpB ) ;
     XtVaSetValues ( ask2_helpB, XmNlabelString, str, NULL ) ;
     XmStringFree ( str ) ; 
   }
   
   DisplayAsk2Dialog ( w, SKY_ASK_EXIT_E, buf ) ;
}

