/* 
 * Source Name : sky_file.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_sat.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
void DisplayImportShell ( char * )  ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/
void
file_okBCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
Sky_ReturnVal_E GetFileNameFromFileSelection ( char * name ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
file_okBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  char            filename [ MAX_FILE_NAME_LEN ] ;
  Sky_LastInfo_S  sky_r ;
  char            old_filename [ MAX_FILE_NAME_LEN ] ;
  LNB_STRUCTURE   lnb_r ;
  TR_STRUCTURE    tp_r ;

  /*------------------------------------------------------------------------*/ 
  /* Get File name */
  /*------------------------------------------------------------------------*/ 
  if ( GetFileNameFromFileSelection ( filename ) != SKY_SUCCESS ) {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : GetFileNameFromFileSelection () Fail\n", __FILE__, __LINE__ ) ;
      #endif

      return ;

  } 
  /*------------------------------------------------------------------------*/ 
  /* Open File */
  /*------------------------------------------------------------------------*/ 
  if ( Sky_ChannelFileOpen ( filename ) != FALSE ) {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Sky_ChannelFileOpen () Fail. File = %s\n", __FILE__, __LINE__, filename ) ;
      #endif

      return ;

   }

  /*------------------------------------------------------------------------*/ 
  /* Open Read */
  /*------------------------------------------------------------------------*/ 
  if ( Sky_ChannelFileRead ( ) != FALSE ) {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Sky_ChannelFileRead () Fail. \n", __FILE__, __LINE__ ) ;
      #endif

      Sky_ChannelFileClose () ;
      return ;
  }

  /*------------------------------------------------------------------------*/ 
  /* Close */
  /*------------------------------------------------------------------------*/ 
  if ( Sky_ChannelFileClose ( ) != FALSE ) {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : Sky_ChannelFileClose () Fail.\n", __FILE__, __LINE__ ) ;
    #endif

    return ;
  }

  /*------------------------------------------------------------------------*/ 
  /* Popup Import Shell */
  /*------------------------------------------------------------------------*/ 
  XtManageChild ( import_board ) ;

  /*------------------------------------------------------------------------*/ 
  /* Display Satellite */
  /*------------------------------------------------------------------------*/ 
  DisplayImportShell ( filename ) ;
}

Sky_ReturnVal_E GetFileNameFromFileSelection ( char * name ) 
{
  char * txt ;

  txt = ( char * ) XmTextGetString ( file_selTxt ) ;
  if ( *txt == ( char ) NULL ) {
  
    #ifdef DEBUG_FAIL
    printf ( "%s : %d : fail to get file\n", __FILE__, __LINE__) ;
    #endif

    return SKY_FAIL ;
  }

  strcpy ( name, txt ) ;
  XtFree ( txt ) ;

  return SKY_SUCCESS ;
}
