/* 
 * Source Name : sky_info2.c
 * Description : information dialog
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#include <sky_extern.h>
#include "sky_inc.h"
#include "sky_info.h"

//////////////////////////////////////////////////////////////////////////////
// EXTERNAL FUNCTION PROTOTYPES
//////////////////////////////////////////////////////////////////////////////
void DisableWidget ( Widget w ) ;
void EnableWidget ( Widget w ) ;
Widget GetParentWidget ( Widget w ) ;

void my_SetWatchCursor ( Widget w1 ) ;
void my_ResetCursor ( Widget w1 ) ;

//////////////////////////////////////////////////////////////////////////////
// INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
//////////////////////////////////////////////////////////////////////////////
void inform2_shell_popupCallback ( Widget w, XtPointer client_data, XtPointer call_data ) ;
void inform2_shell_popdownCallback ( Widget w, XtPointer client_data, XtPointer call_data ) ;

//////////////////////////////////////////////////////////////////////////////
// INTERAL FUNCTION PROTOTYPES 
//////////////////////////////////////////////////////////////////////////////
void DisplayInform2Dialog ( Widget w, InformShell_E, char * txt ) ;
void SetWhoCallInform2Shell ( InformShell_E val ) ;
InformShell_E WhoCallInform2Shell ( void ) ;
void ReSetInform2Shell ( void ) ;

//////////////////////////////////////////////////////////////////////////////
// GLOBAL VARIABLES
//////////////////////////////////////////////////////////////////////////////
static InformShell_E inform2_g ;

//////////////////////////////////////////////////////////////////////////////
// FUNCTION NAME : DisplayInform2Dialog
// DESCRIPTION   : 
// PARAMETERS    : [in]
//                 [out]
// RETURN VALUE  : void
//////////////////////////////////////////////////////////////////////////////
void DisplayInform2Dialog ( Widget w, InformShell_E type, char * txt )
{
   XmString      str ;
   Widget        pW ;

   SetWhoCallInform2Shell ( type ) ;
   
   str = ( XmString ) strToXmString ( txt ) ;
   XtVaSetValues ( inform2_msgLab, XmNlabelString, str, NULL ) ;
   XmStringFree ( str ) ;

#if 0
   //  top level shell disable Ų.
   DisableWidget ( GetParentWidget ( w ) ) ;
#else
   my_SetWatchCursor ( data_shell ) ;
#endif
   XtManageChild ( inform2_msgBox ) ;
}

/*
** X-Designer Stub inform_shell_popupCallback
*/

void
inform2_shell_popupCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   #ifdef DEBUG
   printf ( "inform2_shell_popupCallback : w = %x\n", w ) ;
   #endif
}

/*
** X-Designer Stub inform_shell_popdownCallback
*/

void
inform2_shell_popdownCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   #ifdef DEBUG
   printf ( "inform2_shell_popdownCallback\n" ) ;
   #endif

   /* Get Parent Widget & Enabled */
#if 0
   EnableWidget ( GetParentWidget ( NULL ) ) ;
#else
   my_ResetCursor ( data_shell ) ; 
#endif

   if ( ( WhoCallInform2Shell ( ) == SKY_INFORM_AUTOSCAN_FINISHED_E ) &&
        ( XtIsManaged ( autoscan_board ) == True ) ) {
      XtUnmanageChild ( autoscan_board ) ;
      ReSetInform2Shell () ;
   }

}
void SetWhoCallInform2Shell ( InformShell_E val )
{
   inform2_g = val ;
}
InformShell_E WhoCallInform2Shell ( void )
{
   return inform2_g ;
}
void ReSetInform2Shell ( void )
{
   inform2_g = SKY_INFORM_UNKOWN_E ;
}

void
inform2_okBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
   #ifdef DEBUG
   printf ( "inform2_okBCallback\n" ) ;
   #endif

   switch ( WhoCallInform2Shell ( ) ) {
      case SKY_INFORM_AUTOSCAN_FINISHED_E :

         #ifdef DEBUG
         printf ( "SKY_INFORM_AUTOSCAN_FINISHED_E\n" ) ;
         #endif

         XtUnmanageChild ( autoscan_board ) ;
         break ;
      default :
         break ;
   }
   ReSetInform2Shell () ;
}
void
inform2_cancelBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
}
