#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/ToggleBG.h>

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>

#include "sky_extern.h"
#include "sky_pixmap.h"
#include "sky_windows.h"
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"

/**************************************************************************
 * EXTERNAL FUNCTION PROTOTYPES
 **************************************************************************/
Sky_ReturnVal_E open_initfile ( void ) ;
Sky_ReturnVal_E read_initfile ( Sky_LastInfo_S * lastinfo_p ) ;
Sky_ReturnVal_E write_initfile ( Sky_LastInfo_S * lastinfo_p ) ;
Sky_ReturnVal_E close_initfile ( void ) ;
void ResetNetworkPIDs ( int tp_id ) ;
void AutoScanProgressBar_Initialization ( void ) ;
void LocalOscillatorList_Display ( void ) ;
void LockStatus_DisplayToTitle ( char * , TR_STRUCTURE * tp_p, int sts ) ;
void LockStatus_ResetDisplayToTitle ( char * ) ;
void LocalOscillator_Widgetmask ( void ) ;
void LocalOscillatorList_FirstDisplay ( void ) ;
void LocalOscillatorInfo_Write ( void ) ;
Sky_ReturnVal_E Get_NextSatelliteFileName ( char * outp ) ;
Sky_ReturnVal_E APP_Sky_ReleaseAllNetworkPID ( int tp_id ) ;
Sky_ReturnVal_E LocalIpAddressInfo_Write ( void ) ;

/**************************************************************************
 * INTERNAL FUNCTION PROTOTYPES
 **************************************************************************/
Sky_ReturnVal_E initialize_global_value ( void ) ;
Sky_ReturnVal_E initialize_program ( void ) ;
void finish_sky_media200 ( void ) ;
void DataSetup ( void ) ;
void APP_SignalHandler ( int signo ) ;
void APP_EventHandler ( void ) ;

/**************************************************************************
 * Internal Global Variables
 **************************************************************************/
#if 0
Widget           * vol_stick_g [ MAX_VOLUME_NUM ] ;
#endif
Widget           * agc_stick_g [ MAX_VOLUME_NUM ] ;
Widget           * ber_stick_g [ MAX_VOLUME_NUM ] ;

Sky_ReturnVal_E initialize_global_value ( void )
{
#if 0
   vol_stick_g [ 0 ] = & sky_vol1 ;
   vol_stick_g [ 1 ] = & sky_vol2 ;
   vol_stick_g [ 2 ] = & sky_vol3 ;
   vol_stick_g [ 3 ] = & sky_vol4 ;
   vol_stick_g [ 4 ] = & sky_vol5 ;
   vol_stick_g [ 5 ] = & sky_vol6 ;
   vol_stick_g [ 6 ] = & sky_vol7 ;
   vol_stick_g [ 7 ] = & sky_vol8 ;
   vol_stick_g [ 8 ] = & sky_vol9 ;
   vol_stick_g [ 9 ] = & sky_vol10 ;
   vol_stick_g [ 10 ] = & sky_vol11 ;
   vol_stick_g [ 11 ] = & sky_vol12 ;
   vol_stick_g [ 12 ] = & sky_vol13 ;
   vol_stick_g [ 13 ] = & sky_vol14 ;
   vol_stick_g [ 14 ] = & sky_vol15 ;
   vol_stick_g [ 15 ] = & sky_vol16 ;
   vol_stick_g [ 16 ] = & sky_vol17 ;
   vol_stick_g [ 17 ] = & sky_vol18 ;
   vol_stick_g [ 18 ] = & sky_vol19 ;
   vol_stick_g [ 19 ] = & sky_vol20 ;
#endif
   agc_stick_g [ 0 ] = & lock_agc_1 ;
   agc_stick_g [ 1 ] = & lock_agc_2 ;
   agc_stick_g [ 2 ] = & lock_agc_3 ;
   agc_stick_g [ 3 ] = & lock_agc_4 ;
   agc_stick_g [ 4 ] = & lock_agc_5 ;
   agc_stick_g [ 5 ] = & lock_agc_6 ;
   agc_stick_g [ 6 ] = & lock_agc_7 ;
   agc_stick_g [ 7 ] = & lock_agc_8 ;
   agc_stick_g [ 8 ] = & lock_agc_9 ;
   agc_stick_g [ 9 ] = & lock_agc_10 ;
   agc_stick_g [ 10 ] = & lock_agc_11 ;
   agc_stick_g [ 11 ] = & lock_agc_12 ;
   agc_stick_g [ 12 ] = & lock_agc_13 ;
   agc_stick_g [ 13 ] = & lock_agc_14 ;
   agc_stick_g [ 14 ] = & lock_agc_15 ;
   agc_stick_g [ 15 ] = & lock_agc_16 ;
   agc_stick_g [ 16 ] = & lock_agc_17 ;
   agc_stick_g [ 17 ] = & lock_agc_18 ;
   agc_stick_g [ 18 ] = & lock_agc_19 ;
   agc_stick_g [ 19 ] = & lock_agc_20 ;

   ber_stick_g [ 0 ] = & lock_ber_1 ;
   ber_stick_g [ 1 ] = & lock_ber_2 ;
   ber_stick_g [ 2 ] = & lock_ber_3 ;
   ber_stick_g [ 3 ] = & lock_ber_4 ;
   ber_stick_g [ 4 ] = & lock_ber_5 ;
   ber_stick_g [ 5 ] = & lock_ber_6 ;
   ber_stick_g [ 6 ] = & lock_ber_7 ;
   ber_stick_g [ 7 ] = & lock_ber_8 ;
   ber_stick_g [ 8 ] = & lock_ber_9 ;
   ber_stick_g [ 9 ] = & lock_ber_10 ;
   ber_stick_g [ 10 ] = & lock_ber_11 ;
   ber_stick_g [ 11 ] = & lock_ber_12 ;
   ber_stick_g [ 12 ] = & lock_ber_13 ;
   ber_stick_g [ 13 ] = & lock_ber_14 ;
   ber_stick_g [ 14 ] = & lock_ber_15 ;
   ber_stick_g [ 15 ] = & lock_ber_16 ;
   ber_stick_g [ 16 ] = & lock_ber_17 ;
   ber_stick_g [ 17 ] = & lock_ber_18 ;
   ber_stick_g [ 18 ] = & lock_ber_19 ;
   ber_stick_g [ 19 ] = & lock_ber_20 ;
}
Sky_ReturnVal_E initialize_program ( void )
{
   int              i ;
   int              rt ;
   Sky_ReturnVal_E  ret1 ;
   int              ret2 ;
   Sky_LastInfo_S   lastinfo_p ;
   char             filename [ 100 ] ;

   LNB_STRUCTURE    lnbinfo ;
   TR_STRUCTURE     tpinfo ;

   int              numTp ;
   int              error ;

   /*-------------------------------------*/
   /* Sky-Media Default Calling Functions */ 
   /*-------------------------------------*/
   /* false : , true :  */
   
   if ( ( Sky_OpenSystem ( DATA_APP ) != FALSE ) ||
        ( Sky_StartSystem ( ) != FALSE ) )
   {
      printf ( "Initialization fail\n" ) ;
      #ifdef DEBUG_FAIL
      #endif

      exit ( 0 ) ;
   } 
   /*-------------------------------------*/
   /* Sky-Media Last Status Value         */
   /*-------------------------------------*/
   /* stellite info */
   if ( open_initfile ( ) != SKY_SUCCESS ) {

      #ifdef DEBUG_FAIL
      printf ( "open_initfile () fail -> Terminating ...\n" ) ;
      #endif

      /*
      return SKY_FAIL ;
      */
      exit ( 0 ) ;

   }

   /*----------------------------------------------------------------*/
   /* Reset Transponder Info */
   /*----------------------------------------------------------------*/
   if ( Sky_FreeTransponderStructure ( ) != FALSE ) {
     #ifdef DEBUG_FAIL
     printf ( "%s : %d : Sky_FreeTransponderStructure () Fail\n", __FILE__, __LINE__ ) ;
     #endif
   }

   ret1 = read_initfile ( & lastinfo_p ) ;

   for ( i = 0, error = 0 ; ; i ++ ) { 

     /*---------------------------------------*/
     /*   ̸ */
     /*---------------------------------------*/
     if ( i ) { 
       if ( Get_NextSatelliteFileName ( filename ) != SKY_SUCCESS ) {

          #ifdef DEBUG_FAIL
          printf ( "%s : %d : get_filename () Fail. SatName = %s\n", __FILE__, __LINE__, lastinfo_p . satellite_name ) ;
          #endif

          error = 1 ;
          break ;
       }
     } else {
       if ( get_filename ( lastinfo_p . satellite_name, filename ) != SKY_SUCCESS ) {

          #ifdef DEBUG_FAIL
          printf ( "%s : %d : get_filename () Fail. SatName = %s\n", __FILE__, __LINE__, lastinfo_p . satellite_name ) ;
          #endif

          continue ;
       }
     }

     #ifdef DEBUG
     printf ( "%s : %d : SatName = %s, fileName = %s\n", __FILE__, __LINE__, lastinfo_p . satellite_name, filename ) ;
     #endif

     if ( Sky_ChannelFileOpen ( filename ) != FALSE ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : Sky_ChannelFileOpen () Fail. File = %s\n", __FILE__, __LINE__, filename ) ;
        #endif

        continue ;
     }
     if ( Sky_ChannelFileRead ( ) != FALSE ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : Sky_ChannelFileRead () Fail. \n", __FILE__, __LINE__ ) ;
        #endif

        continue ;
     }
     if ( Sky_ChannelFileClose ( ) != FALSE ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : Sky_ChannelFileClose () Fail.\n", __FILE__, __LINE__ ) ;
        #endif

        continue ;
     }

     break ;
   }

   if ( ! error ) {

      if ( Sky_GetSatelliteInformation ( & lnbinfo ) != FALSE ) {
         #ifdef DEBUG_FAIL
         printf ( "%s : %d : Sky_GetSatelliteInformation () Fail.\n", __FILE__, __LINE__ ) ;
         #endif
      }
   
      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Sat Name = %s\n", __FILE__, __LINE__, lnbinfo.SatelliteName ) ;
      #endif
   
      read_initfile ( & lastinfo_p ) ;
      numTp = Sky_GetNumOfTransponder ()  ;
      if ( numTp == 0 ) {
        lastinfo_p . transponder_id = 0 ;
      } else if ( ( lastinfo_p . transponder_id <= 0 ) && numTp ) {
        lastinfo_p . transponder_id = 1 ;
      } else if ( lastinfo_p . transponder_id > numTp ) {
        lastinfo_p . transponder_id = 1 ;
      }
      write_initfile ( & lastinfo_p ) ;
   
     #ifdef DEBUG
     printf ( "%s : %d : trasponder id = %d\n", __FILE__, __LINE__, lastinfo_p . transponder_id ) ;
     #endif
   
      if ( numTp ) {
         if ( ( rt = Sky_GetInfoTransponder ( lastinfo_p . transponder_id, & tpinfo ) ) != FALSE ) {
   
            #ifdef DEBUG_FAIL
            printf ( "%s : %d : Sky_GetInfoTransponder () Fail.\n", __FILE__, __LINE__ ) ;
            #endif
   
         } else if ( Sky_ReleaseAllNetworkPID ( ) != FALSE ) {
   
            #ifdef DEBUG_FAIL
            printf ( "%s : %d : Sky_ReleaseAllNetworkPID () Fail.\n", __FILE__, __LINE__ ) ;
            #endif

         } else if ( Sky_TunerLockTest ( lnbinfo, tpinfo ) != SKY_OK ) {
   
            #ifdef DEBUG_FAIL
            printf ( "%s : %d : Sky_TunerLockTest () Fail.\n", __FILE__, __LINE__ ) ;
            #endif
        
            /*---------------------------------------*/
            /* Lock Status Setting To title */
            /*---------------------------------------*/
            LockStatus_ResetDisplayToTitle ( ( char * ) lnbinfo.SatelliteName ) ;
   
         } else {
            /*---------------------------------------*/
            /* Lock Status Setting To title */
            /*---------------------------------------*/
            LockStatus_DisplayToTitle ( ( char * ) lnbinfo.SatelliteName, & tpinfo, ret2 ) ;

            ResetNetworkPIDs ( lastinfo_p . transponder_id ) ;
         }
      } else {
         /*---------------------------------------*/
         /* Lock Status Setting To title */
         /*---------------------------------------*/
         LockStatus_ResetDisplayToTitle ( ( char * ) lnbinfo.SatelliteName ) ;
      }
   } else {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : No Channel File\n", __FILE__, __LINE__ ) ;
      #endif
   }
   
   /*---------------------------------------*/
   /* Data Setup                            */
   /*---------------------------------------*/
   InitializeDataSetup ( ) ;

   /*---------------------------------------*/
   /* Information shell help, cancel button unmanaged */
   /*---------------------------------------*/
   XtUnmanageChild ( inform2_helpB ) ;
   XtUnmanageChild ( inform2_cancelB ) ;

   /*---------------------------------------*/
   /* File selection help button unmanaged */
   /*---------------------------------------*/
   XtUnmanageChild ( file_helpB ) ;

   /*---------------------------------------*/
   /* autoscan progress bar initialize */
   /*---------------------------------------*/
   AutoScanProgressBar_Initialization ( ) ;

   /*---------------------------------------*/
   /* Local oscillator list widget ʱȭ */
   /*---------------------------------------*/
   LocalOscillator_Widgetmask ( ) ;
   LocalOscillatorList_FirstDisplay ( ) ;

   /*---------------------------------------*/
   /* Signal Handler */
   /*---------------------------------------*/
   signal ( SIGINT, APP_SignalHandler ) ;

   APP_EventHandler () ;
}
void finish_sky_media200 ( void ) 
{
   if ( ( Sky_StopSystem ( ) != FALSE ) || ( Sky_CloseSystem ( ) != FALSE ) ) {

      #ifdef DEBUG_FAIL
      printf ( "Finish fail\n" ) ;
      #endif

   } 
   save_skymedia_last_status ( ) ;
   LocalOscillatorInfo_Write ( ) ;
   LocalIpAddressInfo_Write ( ) ;
}

void APP_SignalHandler ( int sig_no ) 
{
  #ifdef DEBUG
  printf ( "%s : %d : signal # %d caught\n",__FILE__, __LINE__, sig_no ) ;
  #endif

  finish_sky_media200 ( ) ;
  exit ( 0 ) ;
}
