/* 
 * Source Name : sky_resize.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <X11/cursorfont.h> /* hochoi */

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#include <Xm/Protocols.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <stdio.h>
#include <errno.h>

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_data.h"
#include "sky_autoscan.h"
#include "sky_ask.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
extern void data_exitBCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void APP_EventHandler ( void ) ;
void APP_PropertyChangeHandler ( Widget w, XtPointer client_data, XtPointer  call_data ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/
static Atom   protocols ;

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void APP_EventHandler ( void )
{

   #ifdef DEBUG
   printf ( "%s : %d\n", __FILE__, __LINE__ ) ; fflush ( stdout ) ;
   #endif

   protocols = XInternAtom ( XtDisplay ( data_shell ) , "WM_DELETE_WINDOW", True ) ;
   XmAddWMProtocolCallback ( data_shell, 
                             protocols, 
                             ( XtCallbackProc ) APP_PropertyChangeHandler, 
                             ( XtPointer ) NULL ) ;

   #ifdef DEBUG
   printf ( "%s : %d\n", __FILE__, __LINE__ ) ; fflush ( stdout ) ;
   #endif

   XtVaSetValues ( data_shell, XmNdeleteResponse, XmDO_NOTHING, 0 ) ;
}
void APP_PropertyChangeHandler ( Widget w, XtPointer client_data, XtPointer call_data )
{

  #ifdef DEBUG
  printf ( "%s : %d : APP_PropertyChangeHandler ()\n", __FILE__, __LINE__ ) ;fflush(stdout ) ;
  #endif

  data_exitBCallback ( data_exitB, NULL, NULL ) ;
}

void my_SetWatchCursor ( Widget w1 )
{
  static Cursor watch = ( Cursor ) NULL ;

  if ( !watch ) {
    watch = XCreateFontCursor ( XtDisplay ( w1 ), XC_watch ) ;
  }

  XDefineCursor ( XtDisplay ( w1 ), XtWindow ( w1 ), watch ) ;
  XmUpdateDisplay ( w1 ) ;
}
void my_ResetCursor ( Widget w1 )
{
  XUndefineCursor ( XtDisplay ( w1 ), XtWindow ( w1 ) ) ;
  XmUpdateDisplay ( w1 ) ;
}

