/* 
 * Source Name : sky_resize.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif
#include <stdio.h>
#include <errno.h>
#include <signal.h>

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_data.h"
#include "sky_sat_osc.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/
void ResizeHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void initialize_signal ( void ) ;
void signal_handler2 ( int signo ) ;

void ButtonPressHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch ) ;
void ButtonReleaseHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch ) ;
void Button1MotionHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch ) ;
/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/
static int g_button_handle = 0 ;
static int g_motion_handle = 0 ;

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void EventHandle_Init ( void )
{
   XtAddEventHandler ( data_board,
                       ButtonPressMask,
                       True,
                       ButtonPressHandler,
                       ( XtPointer ) NULL ) ;
   XtAddEventHandler ( data_board,
                       ButtonReleaseMask,
                       True,
                       ButtonReleaseHandler,
                       ( XtPointer ) NULL ) ;
   XtAddEventHandler ( data_board,
                       Button1MotionMask,
                       True,
                       Button1MotionHandler,
                       ( XtPointer ) NULL ) ;
}
void ButtonPressHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch ) 
{
  *continue_to_dispatch = True ;

  g_button_handle = 1 ;  
  printf ( "1" ) ;fflush(stdout ) ;
}
void ButtonReleaseHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch ) 
{
  *continue_to_dispatch = True ;

  g_button_handle = 0 ;  
  printf ( "2" ) ;fflush(stdout ) ;
}
void Button1MotionHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch ) 
{
  *continue_to_dispatch = True ;

  printf ( "3" ) ;fflush(stdout ) ;
  if ( g_button_handle == 1 ) {
    /* move window */  
    XtMoveWidget ( w, 3,4 ) ;
  }
}
