/* 
 * Source Name : sky_sat_del.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_sat.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void DeleteSatellite ( Widget w ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void DeleteSatellite ( Widget w )
{
  Sky_LastInfo_S     sky_r ;
  LNB_STRUCTURE      lnb_p ;
  int                i ;
  char               buf [ 200 ] ;

  /* init file list  */
  read_initfile ( & sky_r ) ;

  /*--------------------------------------------------------*/
  /* get satellite information from driver */
  /*--------------------------------------------------------*/
  memset ( & lnb_p, 0, sizeof ( lnb_p ) ) ;
  if ( Sky_GetSatelliteInformation ( & lnb_p ) != FALSE ) {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : Sky_GetSatelliteInformation () Fail\n", __FILE__, __LINE__ ) ;
    #endif

    DisplayErrorDialog ( w, "Can't get satellite information" ) ;
    return ;
  }

  /*-----------------------------------------------------------------------*/
  /* compare satellite name */
  /*-----------------------------------------------------------------------*/
  for ( i = 0 ; i < MAX_SATELLITE_NUM ; i ++ ) {
    if ( ! strcmp ( ( char * )lnb_p.SatelliteName, sky_r . sat_list [ i ] . satellite_name ) ) {
      memset ( & sky_r. sat_list [ i ], 0, sizeof ( Sky_SatelliteEntry_S ) );
      sky_r . num_of_satellite = sky_r . num_of_satellite - 1 ;
      break ;
    }
  }
  if ( i == MAX_SATELLITE_NUM ) { /* invalid Satellite */
    DisplayErrorDialog ( w, "Can't get satellite information" ) ;
    return ;
  } 

  /* init file ù°  retrieve Ѵ. */
  for ( i = 0 ; i < MAX_SATELLITE_NUM ; i ++ ) {
    if ( sky_r . sat_list [ i ] . flag == 1 ) {
      strcpy ( sky_r . satellite_name, sky_r . sat_list [ i ] . satellite_name ) ;
      strcpy ( sky_r . satellite_file, sky_r . sat_list [ i ] . satellite_file ) ;
      sky_r . transponder_id = 0 ;
      break ;
    }
  }
  write_initfile ( & sky_r ) ;

  /*------------------------------------------------------------------------*/
  /* Open File */
  /*------------------------------------------------------------------------*/
  if ( Sky_ChannelFileOpen ( sky_r . satellite_file ) != FALSE ) {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Sky_ChannelFileOpen () Fail. File = %s\n", __FILE__, __LINE__, sky_r . satellite_file) ;
      #endif

      sprintf ( buf, "Fail to open satellite file\n( %s )\n", sky_r . satellite_file ) ;
      DisplayErrorDialog ( w, buf ) ;
      return ;
   }

  /*------------------------------------------------------------------------*/
  /* Open Read */
  /*------------------------------------------------------------------------*/
  if ( Sky_ChannelFileRead ( ) != FALSE ) {

      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Sky_ChannelFileRead () Fail. \n", __FILE__, __LINE__ ) ;
      #endif

      Sky_ChannelFileClose () ;

      sprintf ( buf, "Fail to read satellite file\n( %s )\n", sky_r . satellite_file ) ;
      DisplayErrorDialog ( w, buf ) ;

      return ;
  }
  /*------------------------------------------------------------------------*/
  /* Close */
  /*------------------------------------------------------------------------*/
  if ( Sky_ChannelFileClose ( ) != FALSE ) {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : Sky_ChannelFileClose () Fail.\n", __FILE__, __LINE__ ) ;
    #endif

    sprintf ( buf, "Fail to close satellite file\n( %s )\n", sky_r . satellite_file ) ;
    DisplayErrorDialog ( w, buf ) ;

    return ;
  }
  /*-------------------------------------------------------------------*/
  /* COMback Main Panel */
  /*-------------------------------------------------------------------*/
  data_menu_SATBCallback ( NULL, NULL, NULL ) ;

  /*DisplayInform2Dialog ( w, SKY_INFORM_UNKOWN_E, "Deleted Successfully !!" ) ;*/
}
