/* 
 * Source Name : sky_sat_osc_handle.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif
#include <stdio.h>
#include <errno.h>

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_data.h"
#include "sky_sat_osc.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/
void LocaloscillatorList_EnterHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch ) ;
void LocaloscillatorList_LeaveHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void LocalOscillator_Widgetmask ( void ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void LocalOscillator_Widgetmask ( void ) 
{
   XtAddEventHandler ( addsat_oscForm,
                       EnterWindowMask,
                       True,
                       LocaloscillatorList_EnterHandler,
                       ( XtPointer ) NULL ) ;
   XtAddEventHandler ( addsat_oscForm,
                       LeaveWindowMask,
                       True,
                       LocaloscillatorList_LeaveHandler,
                       ( XtPointer ) NULL ) ;

}
void LocaloscillatorList_EnterHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch )
{
  /*XtUnmapWidget ( addsat_oscForm ) ;*/
}
void LocaloscillatorList_LeaveHandler ( Widget w, XtPointer client_data, XEvent * event, Boolean * continue_to_dispatch )
{
  XtUnmapWidget ( addsat_oscForm ) ;
}


