/* 
 * Source Name : sky_sat_osc_text.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif
#include <stdio.h>
#include <errno.h>

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_data.h"
#include "sky_sat_osc.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/
void
tuner_loscTextMdCallback ( Widget w, XtPointer client_data, XmTextVerifyCallbackStruct *call_data ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/
static char g_osc_text_p [ 16 ] ; /* "Universal LNB"   = 13 */

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
tuner_loscTextMdCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmTextVerifyCallbackStruct *call_data;
{
   XmTextVerifyPtr  modify = ( XmTextVerifyPtr ) call_data ;
   XmTextBlock      text   = modify -> text ;

   int              i ;
   int              len = strlen ( LOCAL_OSCILLATOR_ZERO_VAL_STR ) ;

   #ifdef DEBUG
   printf ( "tuner_loscTextMdCallback. length = %d\n", text -> length ) ;
   #endif

/*
   for ( i = 0 ; i < text -> length ; i ++ ) {
      if ( isdigit ( text -> ptr [ i ] ) || isalpha ( text -> ptr [ i ] ) ) {
         modify -> doit = True ;
      } else {
         modify -> doit = False ;
         return ;
      }
   }
*/
   memmove ( g_osc_text_p + modify -> startPos + text -> length,
             g_osc_text_p + modify -> endPos,
             strlen ( g_osc_text_p + modify -> endPos ) + 1 ) ;
   memcpy ( g_osc_text_p + modify -> startPos, text -> ptr, text -> length ) ;

   /*memset ( text -> ptr, '*', text -> length ) ;*/

   #ifdef DEBUG
   printf ( "tuner_loscTextMdCallback. g_osc_text_p = %s\n", g_osc_text_p ) ;
   #endif

   if ( ! strcmp ( g_osc_text_p, LOCAL_OSCILLATOR_ZERO_VAL_STR ) ) {
     DisableWidget ( addsat_22kRB ) ;
   } else if ( ! strcmp ( g_osc_text_p, "0" ) ) {
     DisableWidget ( addsat_22kRB ) ;
   } else {
     EnableWidget ( addsat_22kRB ) ;
   }
}
