/* 
 * Source Name : sky_sat_val_chg.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_sat.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void SAT_ValChg_Reset ( void ) ;
void SAT_ValChg_Set ( void ) ;
int SAT_ValChg_Get ( void ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/
static int g_sat_changed = 0 ;

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void SAT_ValChg_Reset ( void )
{
  g_sat_changed = 0 ;

  XtMapWidget ( tuner_satAddMB ) ;
  XtUnmapWidget ( tuner_satInfoB1_1 ) ;

  XtMapWidget ( tuner_satMenu_menubar ) ;
  XtUnmapWidget ( tuner_satOtherB ) ;
}
void SAT_ValChg_Set ( void )
{
  g_sat_changed = 1 ;

  XtMapWidget ( tuner_satInfoB1_1 ) ;
  XtUnmapWidget ( tuner_satAddMB ) ;

  XtMapWidget ( tuner_satOtherB ) ;
  XtUnmapWidget ( tuner_satMenu_menubar ) ;
}
int SAT_ValChg_Get ( void )
{
  return g_sat_changed ;
}
