/* 
 * Source Name : sky_satfile.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_sat.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void GetSatFileName ( char * inname, char * outname ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void GetSatFileName ( char * inname, char * outname )
{
  int   i ;
  int   j ;
  int   len = strlen ( inname ) ;
  char  buf [ MAX_FILE_NAME_LEN + 1 ] ;

  memset ( buf, 0, sizeof ( buf ) ) ;
  
  for ( i = len - 1, j = 0 ; i >= 0 ; i -- ) {
    if ( inname [ i ] == '/' ) {
      buf [ j ] = 0 ;
      break ; 
    } else {
      buf [ j ++ ] = inname [ i ] ;
    }
  }
  buf [ j ] = 0 ;

  len = strlen ( buf ) ;
  for ( i = 0, j = len - 1 ; i < len ; i ++, j -- ) {
    outname [ i ] = buf [ j ] ;
  }
  outname [ i ] = 0 ;

}
