/* 
 * Source Name : sky_setdata.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_data.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
void AvailableDataLister_Reset ( void ) ;
rcl_return_code AvailableDataLister_Add ( int newId, char * );
void DataList_Format ( unsigned short pid, unsigned short type, char * txt ) ;
void SetDataLister_Reset ( void ) ;
rcl_return_code SetDataLister_Add ( int newId, char * );
void DatList_Format ( u16 pid, u16 type, char * txt ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/
void
data_menu_PEBCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void DisplayDataInfoToPanel ( Widget w, int tp_id ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
data_menu_PEBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  int                    tp_id ;
  Sky_LastInfo_S         sky_r ;

  /*------------------------------------------------------------------------*/
  /* Get Transponder Number */
  /*------------------------------------------------------------------------*/
  read_initfile ( & sky_r ) ;
  tp_id = sky_r . transponder_id ;

  #ifdef DEBUG
  printf ( "%s : %d : transponder id = %d\n", __FILE__, __LINE__, tp_id ) ;
  #endif

#if 0
  if ( tp_id <= 0 ) {

    DisplayErrorDialog ( w, "Warning !!\nNo Transponder; Select Transponder" ) ;
    return ;
  }
#endif

  /*------------------------------------------------------------------------*/
  /* Display Available Data & Set Data Info */
  /*------------------------------------------------------------------------*/
  DisplayDataInfoToPanel ( w, tp_id ) ;
}
void DisplayDataInfoToPanel ( Widget w, int tp_id ) 
{
  int                    i ;
  int                    numData ;
  DATAPROGRAM_STRUCTURE  avadata ;
  SETDATA_STRUCTURE      setdata ;
  char                   txt [ 200 ] ;

  /*------------------------------------------------------------------------*/
  /* Get Data Info */
  /*------------------------------------------------------------------------*/
  memset ( & avadata, 0, sizeof ( avadata ) ) ;
  XmListDeleteAllItems ( data_PE_form1_listLister ) ;
  XmListDeleteAllItems ( data_PE_form3_list_lister ) ;
  AvailableDataLister_Reset ( ) ;
  SetDataLister_Reset ( ) ;

  numData = Sky_GetNumOfData ( tp_id ) ;

  for ( i = 0 ; i < numData ; i ++ ) {
    avadata . DataNumber = tp_id * 100 + i + 1 ;
    if ( Sky_GetInfoData ( & avadata ) != FALSE ) {
      DisplayErrorDialog ( w, "Warning !!\nNo Transponder; Select Transponder" ) ;
      return ;
    }
    
    DataList_Format ( avadata . DataPID, avadata . Encapsulation, txt ) ;
    AvailableDataLister_Add ( avadata . DataNumber, txt );
    
    /*----------------------------------------------------------------------*/
    /* Set Data Display */
    /*----------------------------------------------------------------------*/
    if ( avadata . SetFlag ) {
      SetDataLister_Add ( avadata . DataNumber, txt );
    }
  }
}

