/* 
 * Source Name : sky_title.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_sat.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
void TransponderLockStatus ( int lock, char * txt ) ; /* *trans3_list.c */

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void LockStatus_DisplayToTitle ( char * , TR_STRUCTURE * tp_p, int sts ) ;
void LockStatus_ResetDisplayToTitle ( char * ) ;
void LockStatus_GetString ( char * name, TR_STRUCTURE * tp_p, int sts, char * txt ) ;
void LockStatus_SetString ( char * txt ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

extern char card_name[];

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void LockStatus_DisplayToTitle ( char * name, TR_STRUCTURE * tp_p, int sts )
{
  char  txt [ 1024 ] ;
  char  buf [ 10 ] ;

#if 0
  TransponderLockStatus ( sts, buf ) ;
  sprintf ( txt, "SkyMedia-200 Data - %s, %.3f[MHz],%.3f[MSymbol] %s",
            lnb_p -> SatelliteName, 
            ( ( float ) tp_p -> DownlinkFrequency / 1000.0 ), 
            ( ( float ) tp_p -> SymbolRate / 1000.0 ), 
            buf ) ;
#endif
  sprintf ( txt, "%s Data - %s, %.3f[MHz],%.3f[MSymbol]",card_name,
            name,
            ( ( float ) tp_p -> DownlinkFrequency / 1000.0 ), 
            ( ( float ) tp_p -> SymbolRate / 1000.0 ) ) ;

  XtVaSetValues ( data_shell, XmNtitle, txt, NULL ) ;
}
void LockStatus_ResetDisplayToTitle ( char * name )
{
  char  txt [ 1024 ] ;

  sprintf ( txt, "%s Data - %s", card_name, name ) ;
  XtVaSetValues ( data_shell, XmNtitle, txt, NULL ) ;
}
void LockStatus_GetString ( char * name, TR_STRUCTURE * tp_p, int sts, char * txt )
{
  sprintf ( txt, "%s Data - %s, %.3f[MHz],%.3f[MSymbol]",card_name,
            name,
            ( ( float ) tp_p -> DownlinkFrequency / 1000.0 ), 
            ( ( float ) tp_p -> SymbolRate / 1000.0 ) ) ;

}
void LockStatus_SetString ( char * txt ) 
{
  XtVaSetValues ( data_shell, XmNtitle, txt, NULL ) ;
}
