/* 
 * Source Name : sky_trans.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_trans.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
Sky_ReturnVal_E read_initfile ( Sky_LastInfo_S * lastinfo_p ) ;
void allClearTunerPanel ( void ) ; /* sky_new.c */
void display_satellite_name_list ( Sky_LastInfo_S * sky_p ) ;
void display_satellite_lnb_info ( LNB_STRUCTURE * ) ;
void refresh_transponder_info ( void ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/
void
data_menu_SATBCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
data_menu_SATBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  Sky_ReturnVal_E  ret ;
  Sky_LastInfo_S   sky_p ;
  LNB_STRUCTURE    lnbinfo ;

  /***************************************************************************
  ** Read INIT File
  ***************************************************************************/
  read_initfile ( & sky_p ) ;
  
  /***************************************************************************
  ** Display Satellite Info
  ***************************************************************************/
  allClearTunerPanel ( ) ; 

  /***************************************************************************
  ** Display Satellite Info
  ***************************************************************************/
  XmTextSetString ( tuner_satName, sky_p . satellite_name ) ;
  display_satellite_name_list ( & sky_p ) ;

  /***************************************************************************
  ** Display Satellite More Info
  ***************************************************************************/
  if ( Sky_GetSatelliteInformation ( & lnbinfo ) != FALSE ) {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : Sky_GetSatelliteInformation () Fail\n", __FILE__, __LINE__ ) ;
    #endif

    return ;
  }
  display_satellite_lnb_info ( & lnbinfo ) ;

  /***************************************************************************
  ** Display Transponder Info
  ***************************************************************************/
  refresh_transponder_info () ;

}

void
tuner_fqsyBrowseCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmListCallbackStruct *call_data;
{
  XmListCallbackStruct  * data = call_data ;
  Sky_LastInfo_S          sky_r ;

  read_initfile ( & sky_r ) ;
  sky_r . transponder_id = data -> item_position ;
  write_initfile ( & sky_r ) ; 

  #ifdef DEBUG
  printf ( "%s : %d : Transponder Position = %d\n", __FILE__, __LINE__, sky_r . transponder_id ) ;
  #endif
}

