/* 
 * Source Name : sky_trans_add_edit.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_trans.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
void refresh_transponder_info ( void ) ;
void Compare_TP_OldInfo_Set ( int count, TR_STRUCTURE * old_tp ) ;
Sky_ReturnVal_E Compare_Old_With_TP_NewInfo ( int count, TR_STRUCTURE * new_tp ) ;
void List_SelectedScrolled ( Widget w, int pos, int page ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/
void
addtrans_shell_popupCallback ( Widget w, XtPointer client_data, XtPointer call_data ) ;
void
addtrans_shell_popdownCallback ( Widget w, XtPointer client_data, XtPointer call_data ) ;
void
tuner_fqsyAddCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ;
void
tuner_fqsyEditCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ;
void
addtrans_okBCallback ( Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void SetLabelTransponderSubShell ( char * lab ) ;
void ClearTransponderSubShell ( void ) ;
Sky_ReturnVal_E GetValTransponderShell ( TR_STRUCTURE * tp_p ) ;
void SetValTransponderSubShell ( TR_STRUCTURE * tp_p ) ;
TP_B_Select_E GetAddEditTransponder ( void ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void
addtrans_shell_popupCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
#if 0
  XtSetSensitive ( data_shell, False ) ;
#endif
}
void
addtrans_shell_popdownCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XtPointer call_data;
{
#if 0
  XtSetSensitive ( data_shell, True ) ;
#endif
}

void
tuner_fqsyAddCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  SetLabelTransponderSubShell ( TRANSPONDER_ADD_TITLE_STR ) ;
  ClearTransponderSubShell ( ) ;
  XtManageChild ( addtrans_board ) ;
#if 0
  XtSetSensitive ( data_shell, False ) ;
#endif
}

void
tuner_fqsyEditCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  TR_STRUCTURE tp_p ;
  int          pos ;
  int        * position ;

  TR_STRUCTURE old_tp [ MAX_TRANSPONDER_NUM ] ;
  int          old_count ;
  int          i ;
  int          count ;
  Boolean      rt ;

  SetLabelTransponderSubShell ( TRANSPONDER_EDIT_TITLE_STR ) ;
  ClearTransponderSubShell ( ) ;

  /* get transponder position */
#if 1
  pos = XmListGetKbdItemPos ( tuner_satinfo_FqSyList_list ) ; 
  if ( pos == 0 ) {

     #ifdef DEBUG_FAIL
     printf ( "%s : %d : XmListGetKbdItemPos () : empty position\n", __FILE__, __LINE__ ) ;
     #endif

     return ;
  }
#else
  rt = XmListGetSelectedPos ( data_PE_form1_listLister, & position, & count ) ;
  if ( rt != True ) {

     #ifdef DEBUG_FAIL
     printf ( "%s : %d : XmListGetSelectedPos () Fail. count = %d\n", __FILE__, __LINE__, count ) ;
     #endif

     return ;
  }
  if ( count == 0 ) {

     #ifdef DEBUG_FAIL
     printf ( "%s : %d : XmListGetSelectedPos () : empty position\n", __FILE__, __LINE__ ) ;
     #endif

     return ;
  }
  pos = * position ;

#endif

  /* get transponder info */
  memset ( & tp_p, 0, sizeof ( tp_p ) ) ;
  if ( Sky_GetInfoTransponder ( pos, & tp_p ) != FALSE ) {

     #ifdef DEBUG_FAIL
     printf ( "%s : %d : Sky_GetInfoTransponder () Fail\n", __FILE__, __LINE__ ) ;
     #endif

     return ;
  }

  /* setting transponder info */
  SetValTransponderSubShell ( & tp_p ) ;

  /* display addtrans_shell */
  XtManageChild ( addtrans_board ) ;
#if 0
  XtSetSensitive ( data_shell, False ) ;
#endif

  /*--------------------------------------------------------*/
  /* Save Old Transponder Information */
  /*--------------------------------------------------------*/
  old_count = Sky_GetNumOfTransponder ( ) ;
  memset ( old_tp, 0, sizeof ( old_tp ) ) ;
  for ( i = 0 ; i < old_count ; i ++ ) {
    if ( Sky_GetInfoTransponder ( i + 1, & old_tp [ i ] ) != FALSE ) {

       #ifdef DEBUG_FAIL
       printf ( "%s : %d : Sky_GetInfoTransponder () Fail\n", __FILE__, __LINE__ ) ;
       #endif

       return ;
    }
  }
  Compare_TP_OldInfo_Set ( old_count, old_tp ) ;


}

void
addtrans_okBCallback (w, client_data, call_data )
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *call_data;
{
  TR_STRUCTURE   tp_p ;
  TP_B_Select_E  type ;
  int            numOfTrans ;
  int            pos ;

  int            i ;
  int            new_count ;
  TR_STRUCTURE   new_tp [ MAX_TRANSPONDER_NUM ] ;
  Sky_LastInfo_S sky_p ;

  memset ( & tp_p, 0, sizeof ( tp_p ) ) ;

  /*----------------------------------------------------------*/
  /* Get Add/Edit Transponder Value from Pannel */
  /*----------------------------------------------------------*/
  if ( GetValTransponderShell ( & tp_p ) != SKY_SUCCESS ) {
#if 0
    XtSetSensitive ( data_shell, True ) ;
#endif
    return ;
  } 

  /*----------------------------------------------------------*/
  /* Add or Edit ? */
  /*----------------------------------------------------------*/
  switch ( GetAddEditTransponder ( ) ) {
    case TRANS_ADD_E :

      /*------------------------------------------------------*/
      /* get transponder  */
      /*------------------------------------------------------*/
      numOfTrans = Sky_GetNumOfTransponder ( ) ;
      tp_p . TransponderNumber = numOfTrans + 1 ;

      /*------------------------------------------------------*/
      /* Add Transponder */
      /*------------------------------------------------------*/
      if ( Sky_AddTransponder ( & tp_p ) != FALSE ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : Sky_AddTransponder () Fail\n", __FILE__, __LINE__ ) ;
        #endif

      }

      /*------------------------------------------------------*/
      /* Add Transponder */
      /*------------------------------------------------------*/
      SAT_ValChg_Set ( ) ;

      break ;

    case TRANS_EDIT_E :

      /*------------------------------------------------------*/
      /* get transponder id */
      /*------------------------------------------------------*/
      pos = XmListGetKbdItemPos ( tuner_satinfo_FqSyList_list ) ;
      if ( pos == 0 ) {
    
         #ifdef DEBUG_FAIL
         printf ( "%s : %d : XmListGetKbdItemPos () : empty position\n", __FILE__, __LINE__ ) ;
         #endif

         return ;
      }
      tp_p . TransponderNumber = pos ;

      /*------------------------------------------------------*/
      /* Update Transponder */
      /*------------------------------------------------------*/
      if ( Sky_UpdateTransponder ( tp_p ) != FALSE ) {

        #ifdef DEBUG_FAIL
        printf ( "%s : %d : Sky_UpdateTransponder () Fail\n", __FILE__, __LINE__ ) ;
        #endif

      }

      /*------------------------------------------------------*/
      /* Compare Old TP & New TP */
      /*------------------------------------------------------*/
      new_count = Sky_GetNumOfTransponder ( ) ;
      memset ( new_tp, 0, sizeof ( new_tp ) ) ;
      for ( i = 0 ; i < new_count ; i ++ ) {
        if ( Sky_GetInfoTransponder ( i + 1, & new_tp [ i ] ) != FALSE ) {

           #ifdef DEBUG_FAIL
           printf ( "%s : %d : Sky_GetInfoTransponder () Fail\n", __FILE__, __LINE__ ) ;
           #endif

           return ;
        }
      }
      if ( Compare_Old_With_TP_NewInfo ( new_count, new_tp ) == SKY_SUCCESS ) {
        SAT_ValChg_Set ( ) ;
      }

      break ;

    default :
    
      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Invalid Trasnponder Add/Edit?\n", __FILE__, __LINE__ ) ;
      #endif

      return ;
  }

  /*------------------------------------------------------*/
  /* Re-Display Transponder Info */
  /*------------------------------------------------------*/
  refresh_transponder_info () ;
  
  /*------------------------------------------------------*/
  /* List Cursor Move */
  /*------------------------------------------------------*/
#ifdef LINUX_VERSION
  List_SelectedScrolled ( tuner_satinfo_FqSyList_list, tp_p . TransponderNumber, 6 ) ;
#else
  List_SelectedScrolled ( tuner_satinfo_FqSyList_list, tp_p . TransponderNumber, 6 ) ;
#endif

  /***************************************************************************
  ** Current transponder id setting
  ***************************************************************************/
  read_initfile ( & sky_p ) ;
  /*sky_p . transponder_id = XmListGetKbdItemPos ( tuner_satinfo_FqSyList_list ) ;*/
  sky_p . transponder_id = tp_p . TransponderNumber ;
  write_initfile ( & sky_p ) ;

}

Sky_ReturnVal_E GetValTransponderShell ( TR_STRUCTURE * tp_p ) 
{
  char * txt ;
  float  f_tmp ;

  /* get frequency value */
  txt = ( char * ) XmTextGetString ( addtrans_item1_nameTxt ) ;
  if ( *txt == ( char )NULL ) {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : empty frequency\n", __FILE__, __LINE__ ) ;
    #endif

    return SKY_FAIL ;
  }
  sscanf ( txt, "%f", & f_tmp ) ;
  XtFree ( txt ) ;

  if ( f_tmp <= 0.0 ) {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : empty frequency\n", __FILE__, __LINE__ ) ;
    #endif

    return SKY_FAIL ;
  }
  tp_p -> DownlinkFrequency = f_tmp * 1000 ;
  
  /* get symbol rate */
  txt = ( char * ) XmTextGetString ( addtrans_item1_osTxt ) ;
  if ( *txt == ( char )NULL ) {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : empty symbol rate\n", __FILE__, __LINE__ ) ;
    #endif

    return SKY_FAIL ;
  }
  sscanf ( txt, "%f", & f_tmp ) ;
  XtFree ( txt ) ;
  if ( f_tmp <= 0.0 ) {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : empty symbol rate\n", __FILE__, __LINE__ ) ;
    #endif

    return SKY_FAIL ;
  }
  tp_p -> SymbolRate = f_tmp * 1000 ;
  
  /* get signal type */
  if ( XmToggleButtonGetState ( addtrans_item2_polV ) == True ) {
    tp_p -> SignalType = SIGNAL_VERTICAL ;
  } else if ( XmToggleButtonGetState ( addtrans_item2_polH ) == True ) {
    tp_p -> SignalType = SIGNAL_HORIZONTAL ;
  } else {

    #ifdef DEBUG_FAIL
    printf ( "%s : %d : empty signal type\n", __FILE__, __LINE__ ) ;
    #endif

    return SKY_FAIL ;
  }

  return SKY_SUCCESS ;
}
void SetValTransponderSubShell ( TR_STRUCTURE * tp_p ) 
{
  char  txt [ 100 ] ;

  /* frequency */
  sprintf ( txt, "%.3f", ( ( float ) tp_p -> DownlinkFrequency / 1000.0 ) ) ;
  XmTextSetString ( addtrans_item1_nameTxt, txt ) ;

  /* symbol rate */
  sprintf ( txt, "%.3f", ( ( float ) tp_p -> SymbolRate / 1000.0 ) ) ;
  XmTextSetString ( addtrans_item1_osTxt, txt ) ;

  /* signal type */
  if ( tp_p -> SignalType == SIGNAL_VERTICAL ) {
    XmToggleButtonSetState ( addtrans_item2_polV, True, False ) ;
    XmToggleButtonSetState ( addtrans_item2_polH, False, False ) ;
  } else if ( tp_p -> SignalType == SIGNAL_HORIZONTAL ) {
    XmToggleButtonSetState ( addtrans_item2_polV, False, False ) ;
    XmToggleButtonSetState ( addtrans_item2_polH, True, False ) ;
  } else {
    XmToggleButtonSetState ( addtrans_item2_polV, False, False ) ;
    XmToggleButtonSetState ( addtrans_item2_polH, False, False ) ;
  }
}

void SetLabelTransponderSubShell ( char * lab )
{
  XmString   str ;

  str = ( XmString ) strToXmString ( lab ) ;

  /* addtrans_shell title setting */
  XtVaSetValues ( addtrans_shell, XmNtitle, lab, NULL ) ;

  /* addtrans_label setting */
  XtVaSetValues ( addtrans_label, XmNlabelString, str, NULL ) ;

  XmStringFree ( str ) ;
}
void ClearTransponderSubShell ( void )
{

  #ifdef DEBUG
  printf ( "%s : %d : ClearTransponderSubShell ()\n", __FILE__, __LINE__ ) ;
  #endif

  XmTextSetString ( addtrans_item1_nameTxt, "" ) ;
  XmTextSetString ( addtrans_item1_osTxt, "" ) ;
  XmToggleButtonSetState ( addtrans_item2_polV, True, False ) ;
  XmToggleButtonSetState ( addtrans_item2_polH, False, False ) ;
}


TP_B_Select_E GetAddEditTransponder ( void ) 
{
  XmString   str ;
  Boolean    rt ;
  char     * txt ;

  XtVaGetValues ( addtrans_label, XmNlabelString, & str, NULL ) ;
  rt = XmStringGetLtoR ( str, XmFONTLIST_DEFAULT_TAG, & txt ) ;
  if ( rt != True ) {
    #ifdef DEBUG_FAIL
    printf ( "%s : %d : XmStringGetLtoR() fail\n", __FILE__, __LINE__ ) ;
    #endif

    return TRANS_UNKNOWN_E ;
  }

  if ( ! strcmp ( txt, TRANSPONDER_ADD_TITLE_STR ) ) {
    return TRANS_ADD_E ;
  } else if ( ! strcmp ( txt, TRANSPONDER_EDIT_TITLE_STR ) ) {
    return TRANS_EDIT_E ;
  } else {
    return TRANS_UNKNOWN_E ;
  }
}
