/* 
 * Source Name : sky_trans_del.c
 * Description : 
 *
 */

/*
**LIBS: -lXm -lXt -lX11
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#ifdef SMARTCARD_VERSION
#include <rpc/rpc.h>
#include <rpc/svc.h>
#endif

#include <sky_extern.h>
#include "sm2_lib.h"
#include "skymedia.h"
#include "sky_skysub.h"
#include "sky_app.h"
#include "sky_inc.h"
#include "sky_sat.h"

/*****************************************************************************
** EXTERNAL FUNCTION PROTOTYPES
*****************************************************************************/
void refresh_transponder_info ( void ) ;

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES ( CallBack Functions )
*****************************************************************************/

/*****************************************************************************
** INTERAL FUNCTION PROTOTYPES 
*****************************************************************************/
void DeleteTransponder ( Widget w ) ;

/*****************************************************************************
** GLOBAL VARIABLES
*****************************************************************************/

/*****************************************************************************
** FUNCTION NAME : 
** DESCRIPTION   :
** PARAMETERS    : [in]
**                 [out]
** RETURN VALUE  : void
*****************************************************************************/
void DeleteTransponder ( Widget w )
{
   int              position ;
   Sky_LastInfo_S   sky_p ;

   /* Transponder Number ? */
   position = XmListGetKbdItemPos ( tuner_satinfo_FqSyList_list ) ;
   if ( position <= 0 ) {
      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Unselected Transponder\n", __FILE__, __LINE__ ) ;
      #endif

      return ;
   }

   if ( Sky_DeleteTransponder ( position ) != FALSE ) {
      #ifdef DEBUG_FAIL
      printf ( "%s : %d : Sky_DeleteTransponder () Fail\n", __FILE__, __LINE__ ) ;
      #endif

      return ;
   }
   /***************************************************************************
   ** Current transponder id setting
   ***************************************************************************/
   read_initfile ( & sky_p ) ;
   if ( Sky_GetNumOfTransponder () ) {
     sky_p . transponder_id = 1 ;
   } else {
     sky_p . transponder_id = 0 ;
   }
   write_initfile ( & sky_p ) ;

   /*-----------------------------------------------*/
   /* Get All Transponder Information and Resetting */
   /*-----------------------------------------------*/
   refresh_transponder_info ( ) ;

}
