#!/bin/sh
module="sm2_lnx"
device="sm200"
group="wheel"
mode="664"

# invoke rmmod with all arguments we got
/sbin/rmmod $module

# invoke insmod with all arguments we got
/sbin/insmod -f $module $* || exit 1

# remove stale nodes
rm -f /dev/$device

major=`cat /proc/devices | awk "\\$2==\"$device\" {print \\$1}"`

mknod /dev/$device c $major 0

# give appropriate group/permissions
chgrp $group /dev/$device
chmod $mode /dev/$device

